/*
 *	pa.h -- Definitions for Parsonal Arm PA10
 *
 *	Copyright (c) Mitsubisgi Heavy Industries, 1993
 *
 */

#ifndef _PA_H_
#define _PA_H_

#define	_PA_	10

/* 
 * 	üʰ̣ĥǡ 
 */
typedef float 	MATRIX[3][4];	/* 					*/
typedef float 	NOAMAT[3][3];	/* noa				*/
typedef float 	VECTOR[3];	/* ٥ȥ				*/

/*
 * ǡեޥåֹ
 */
#define	COM_FMT00	0
#define	COM_FMT01	1
#define	COM_FMT02	2
#define	COM_FMT03	3
#define	COM_FMT04	4
#define	COM_FMT05	5
#define	COM_FMT06	6
#define	COM_FMT07	7
#define	COM_FMT08	8
#define	COM_FMT09	9
#define	COM_FMT10	10
#define	COM_FMT11	11

/* 
 *	
 */
typedef unsigned long	ARM;
#define	ARM0	(ARM)0
#define	ARM1	(ARM)1
#define	ARM2	(ARM)2
#define	ARM3	(ARM)3
#define	ARM4	(ARM)4
#define	ARM5	(ARM)5
#define	ARM6	(ARM)6
#define	ARM7	(ARM)7
#define	ARM8	(ARM)8
#define	ARM9	(ARM)9
#define	ARM10	(ARM)10
#define	ARM11	(ARM)11
#define	ARM12	(ARM)12
#define	ARM13	(ARM)13
#define	ARM14	(ARM)14
#define	ARM15	(ARM)15

/* 
 *	ؿΥǡ
 */
#define	WM_WAIT		0
#define	WM_NOWAIT	1

/* 
 * Ƽǡ¤ 
 */
typedef struct {
	float s1;
	float s2;
	float s3;
	float e1;
	float e2;
	float w1;
	float w2;
}ANGLE, *ANGLEP;


/* 
 * ǡ¤ 
 */
typedef struct {
	float	agl[7];
	float	vel[2];
	long	atr[12];
} PLYPNT, *PLYPNTP;

typedef struct {
	PLYPNT	pnt;
	char	cmt[32];
} PLAY, *PLAYP;

/*

*/
typedef struct {
	float	xyz[3];
	float	noa[3][3];
} NOAP, *NOAPP;

/*
	JUMP¤
*/
typedef struct {
	long	cnd[2];
	long	xdi;
	long	tim;
	long	key;
	long	pid;
	long	cnt;
}JUDGE, *JUDGEP;

typedef struct {
	long	cid;
	JUDGE	jdg[8];
}JUMP, *JUMPP;

typedef struct {
	PLAY	ply;
	NOAP	noa;
	JUMP	jmp;
}PNTDAT, *PNTDATP;

/* 
 * Υơ¤ 
 */
typedef struct {
    	long		max;		//'ܡɤǽ   1or2
    	long		arm;		//'Ȥܤˤ뤫    0or1
	long		axis;		//'༴
    	long	    typ;		//'ॿ
    	long		drv;		//'ܥɥ饤м
    	long		dio;		//'ĥDIOܡ̵ͭ
	long		remote;		//'⡼ɡ̵ͭ
	long		count;		//'楫
	long		error;		//'顼
	ANGLE		angle;		//'ߤμ
	MATRIX		noap;		//'ߤü
	float		ypr[3];		//'ߤλ
}ARMSTATUS, *ARMSTATUSP;

/* 
 * ǥ롡ɡϤι¤
 */
typedef struct {
	unsigned char		io1;	/*DIO 1ch*/
	unsigned char		io2;	/*DIO 2ch*/
	unsigned char		io3;	/*DIO 3ch*/
	unsigned char		io4;	/*DIO 4ch*/
}DIOSTATUS, *DIOSTATUSP;

/* 
 * ѥ᡼¤
 */
typedef struct {
	float	rezl;			/* 쥾ʬǽ		*/
	float	pul[7];			/* ֥ߥåʡܡ		*/
	float	pdl[7];			/* ֥ߥåʡݡ		*/
	float	vel[7 + 2];		/* ®٥ߥå			*/
	float	dev[7 + 2];		/* ǥե®		*/
	float	lim[7 + 2];		/* 				*/
	float	ceh[7 + 2];		/* 				*/
	float	cem[7 + 2];		/* 				*/
	float	cel[7 + 2];		/* 				*/
	float	pg1[7];			/* 楲		*/
	float	pg2[7];			/* 楲		*/
	float	vg1[7];			/* ®楲		*/
	float	tg1[7];			/* 楲			*/
	float	pcm[7];			/* 		*/
	float	fcm[7];			/*   		*/
	float	arl[7];			/* ݥĹ			*/
	float	arg[7];			/* Ƽſ			*/
	float	arw[7];			/* Ƽ			*/
	float	hom[7];			/* ܻɸ		*/
	float	saf[7];			/* ¾ɸ		*/
	float	esc[7];			/* ɸ		*/
	float	tol[7];			/* ѥݥ		*/
	float	fvl[7];			/* 				*/
	long	dmy[7];			/* ӥ󥰥ѥ᡼	*/
	long	spa[7];			/* ͽ				*/
} PARAM, *PARAMP;

/* 
 *	
 */
typedef unsigned long	AXIS;
#define	S1	(AXIS)0x01
#define	S2	(AXIS)0x02
#define	S3	(AXIS)0x04
#define	E1	(AXIS)0x08
#define	E2	(AXIS)0x10
#define	W1	(AXIS)0x20
#define	W2	(AXIS)0x40

#define	AXISALL		(S1|S2|S3|E1|E2|W1|W2)
#define	ALLAXIS		(S1|S2|S3|E1|E2|W1|W2)
#define	LOCKAXIS_S1	(S2|S3|E1|E2|W1|W2)
#define	LOCKAXIS_S3	(S1|S2|E1|E2|W1|W2)

/*
 *	ܥɥ饤м
 */
typedef unsigned long	DRIVER;
#define	DRV1	(DRIVER)0
#define	DRV2	(DRIVER)1
#define	DRV3	(DRIVER)2
#define	DRV4	(DRIVER)3

/*	
 *	ץ쥤Хå⡼
 */
typedef unsigned long	PLAYBACK;
#define	PB_FORES	(PLAYBACK)0
#define	PB_BACKS	(PLAYBACK)1
#define	PB_FORE		(PLAYBACK)2
#define	PB_BACK		(PLAYBACK)3

/*
 *	
 */
typedef unsigned long	PNTDEL;
#define	PD_CUR		(PNTDEL)0x7500	/*ݥȤζ	*/
#define	PD_FORE		(PNTDEL)0x7501	/*ݥȤζ	*/
#define	PD_ALL		(PNTDEL)0x7502	/*ƤΥƥֶκ	*/
#define	PD_ALLDATA	(PNTDEL)0	/*Ƥζκ		*/

/*
 *	°
 */
typedef unsigned long	PNTATTR;
#define	PA_CHGVEL	(PNTATTR)0x7300
#define	PA_CHGWAIT	(PNTATTR)0x7301
#define	PA_VELPTN	(PNTATTR)0x7302	/* ǡ®٥ѥ	*/
#define	PA_ROTVEL	(PNTATTR)0x7303	/* ǡž®		*/
#define	PA_AXSACC	(PNTATTR)0x7304	/* Ƽ			*/
#define	PA_RMRCACC	(PNTATTR)0x7305	/* ľ			*/
#define	PA_JUMPID	(PNTATTR)0x7306	/* JUMPֹ			*/

/*
 *	
 */
typedef unsigned long	PNTTYPE;
#define	PT_CP		(PNTTYPE)0x7100
#define	PT_PTP		(PNTTYPE)0x7101
#define	PT_BCP		(PNTTYPE)0x7102
#define	PT_BPTP		(PNTTYPE)0x7103
#define	PT_ARC1		(PNTTYPE)0x7104
#define	PT_ARC2		(PNTTYPE)0x7105
#define	PT_ARC3		(PNTTYPE)0x7106
#define	PT_CIR1		(PNTTYPE)0x7107
#define	PT_CIR2		(PNTTYPE)0x7108
#define	PT_CIR3		(PNTTYPE)0x7109
#define	PT_AXS		(PNTTYPE)0x710a
#define	PT_BAXS		(PNTTYPE)0x710b
#define	PT_POS		(PNTTYPE)0x710c
#define	PT_BPOS		(PNTTYPE)0x710d
#define	PT_ARC4		(PNTTYPE)0x710e
#define	PT_ARC5		(PNTTYPE)0x710f
#define	PT_ARC6		(PNTTYPE)0x7110
#define	PT_CIR4		(PNTTYPE)0x7111
#define	PT_CIR5		(PNTTYPE)0x7112
#define	PT_CIR6		(PNTTYPE)0x7113

/*
 *	Υݥ
 */
typedef unsigned long	PNTMOVE;
#define	PM_TOP	(PNTMOVE)0x7100	/* Ƭ				*/
#define	PM_NEXT	(PNTMOVE)0x7101	/* 					*/
#define	PM_PRIV	(PNTMOVE)0x7102	/* 					*/
#define	PM_BTM	(PNTMOVE)0x7103	/* Ǹ				*/
#define	PM_JMP	(PNTMOVE)0x7104	/* ꥢɥ쥹			*/
#define	PM_CIR	(PNTMOVE)0x7105	/* ߶򸡺ǽȯ */
#define	PM_ARC	(PNTMOVE)0x7106	/* ߸̡"			    */

/*
 *	ǥե®ѹ
 */
typedef unsigned long	VELTYPE;
#define	VT_ONEVEL	(VELTYPE)0	/* Ƽǥե®		*/
#define	VT_XYZVEL	(VELTYPE)1	/* ü֥ǥե®ѹ	*/
#define	VT_YPRVEL	(VELTYPE)2	/* üǥե®ѹ	*/

/*
 *	®
 */
typedef unsigned long	VELMODE;
#define	VM_XYZ		(VELMODE)0x200
#define	VM_YPR		(VELMODE)0x201
#define	VM_xyz		(VELMODE)0x202
#define	VM_ypr		(VELMODE)0x203
#define	VM_ONE		(VELMODE)0x204
#define	VM_XYZYPR	(VELMODE)0x205
#define	VM_xyzypr	(VELMODE)0x206

/*
 *	Ĺ⡼
 */
typedef unsigned long	JOUMODE;
#define	JM_SET		(JOUMODE)0X345
#define	JM_RESET	(JOUMODE)0X346
#define	JM_VSET		(JOUMODE)0X347
#define	JM_ON		(JOUMODE)0X348
#define	JM_OFF		(JOUMODE)0X349
#define	JM_S3ON		(JOUMODE)0X34a
#define	JM_S3DIV	(JOUMODE)0X34b
#define	JM_S3HOLD	(JOUMODE)0X34c

/*
 *	Ĺ⡼
 */
typedef unsigned long	JOUTYPE;
#define	JT_RIGHT	(JOUTYPE)1
#define	JT_HOLD		(JOUTYPE)0
#define	JT_LEFT		(JOUTYPE)-1

/*
 *	
 */
typedef unsigned long	MOVEMODE;
#define	MM_XYZ		(MOVEMODE)0x5680
#define	MM_NOA		(MOVEMODE)0x5681
#define	MM_XYZNOA	(MOVEMODE)0x5682

/*
 *	
 */
typedef unsigned long	DIRECTMODE;
#define	DM_STOP		(DIRECTMODE)0
#define	DM_START	(DIRECTMODE)1

#define	ARM_STANDING	 1	/* ֤ */
#define	ARM_HANGING	-1	/* ŷߤ */

/*
 *	DIO ݡֹ
 */
typedef unsigned long	DIOPORT;
#define	DP_PORT1	(DIOPORT)0
#define	DP_PORT2	(DIOPORT)1
#define	DP_PORT3	(DIOPORT)2
#define	DP_PORT4	(DIOPORT)3
#define	DPO_PORT1	(DIOPORT)4
#define	DPO_PORT2	(DIOPORT)5
#define	DPO_PORT3	(DIOPORT)6
#define	DPO_PORT4	(DIOPORT)7
#define	DPX_PORT1	(DIOPORT)8
#define	DPX_PORT2	(DIOPORT)9
#define	DPX_PORT3	(DIOPORT)10
#define	DPX_PORT4	(DIOPORT)11

/*
 *	DIO channalֹ
 */
typedef unsigned long	DIOCH;
#define	DC_CH1	(DIOCH)0
#define	DC_CH2	(DIOCH)1
#define	DC_CH3	(DIOCH)2
#define	DC_CH4	(DIOCH)3
#define	DC_CH5	(DIOCH)4
#define	DC_CH6	(DIOCH)5
#define	DC_CH7	(DIOCH)6
#define	DC_CH8	(DIOCH)7

/*
 *	ݥӥ󥰤ȥκɸϼ
 */
typedef unsigned long		TRANSMODE;
#define	MODE_xyz	(TRANSMODE)0x01
#define	MODEIxyz	(TRANSMODE)0x02
#define	MODE_XYZ	(TRANSMODE)0x04
#define	MODEIXYZ	(TRANSMODE)0x08
#define	MODE_wave	(TRANSMODE)0x10
#define	MODEIwave	(TRANSMODE)0x20

/*
 *	°
 */
typedef unsigned long	PNTID;
#define	PA_SETID	(PNTID)0x7304

/*
 *	ߡ߸̤ζΣ
 */
typedef unsigned long	PNTNO;
#define	PN_1 	(PNTNO)1
#define	PN_2 	(PNTNO)2
#define	PN_3 	(PNTNO)3

/*
 *      JUMPͭ/̵ʶǡˤơ
 */
typedef unsigned long	JUMPONOFF;
#define JMP_ON     (JUMPONOFF)1		//'/* ON"    */
#define JMP_OFF    (JUMPONOFF)0		//'/* OFF "    */

/*
 *	JUMPͭ/̵JUMPˤơ
 */
typedef unsigned long	JUMPENABLEDISABLE;
#define	JMPENABLE 	(JUMPENABLEDISABLE)0x01000000
#define	JMPDISABLE 	(JUMPENABLEDISABLE)0x00000000

/*
 *	JUMP̿
 */
typedef unsigned long	JUMPORDER;
#define	NO_JUMP		(JUMPORDER)0x00010000
#define	DI_JUMP 	(JUMPORDER)0x00020000
#define	DI_WAITJUMP 	(JUMPORDER)0x00030000
#define	DI_WAIT 	(JUMPORDER)0x00040000

/*
 *	JUMP
 */
typedef unsigned long	JUMPDILOGIC;
#define	LEVEL_ON 	(JUMPDILOGIC)0x00000100
#define	LEVEL_OFF	(JUMPDILOGIC)0x00000200
#define	EDGE_ON 	(JUMPDILOGIC)0x00000400
#define	EDGE_OFF	(JUMPDILOGIC)0x00000800

/*
 *	JUMPåоDI
 */
typedef unsigned long	DIOKIND;
#define	DIO_INTERNAL	(DIOKIND)0x00000000
#define	DIO_EXTERNAL	(DIOKIND)0x00000001

/*
 *  CUBE
 */
typedef unsigned long	CUBEPNT;
#define MAXPNT    (CUBEPNT)1
#define MINPNT    (CUBEPNT)2
#define CENTERPNT (CUBEPNT)3

/*
 *	mask
 */
typedef unsigned long	DIOMASK;
#define	DIMSK	 	(DIOMASK)0
#define	DOMSK		(DIOMASK)1

/*
 *  RETRACON/OFF
 */
typedef unsigned long	RETRAC;
#define RETRACOFF    (RETRAC)0
#define RETRACON     (RETRAC)1

/*
 *  CUBE
 */
typedef unsigned long	CUBEINFO;
#define NOCUBE       (CUBEINFO)0x00000000
#define CUBEON       (CUBEINFO)0x00000001
#define CUBEMAX      (CUBEINFO)0x00000002
#define CUBEMIN      (CUBEINFO)0x00000004
#define CUBECENTER   (CUBEINFO)0x00000008
#define CUBESIDE     (CUBEINFO)0x00000010


/*
 *	TEACHMODE
 */
typedef unsigned long	TEACHMODE;
#define	TEACH_OFF 	(TEACHMODE)0
#define	TEACH_LOW	(TEACHMODE)1
#define	TEACH_MID	(TEACHMODE)2
#define	TEACH_HIGH	(TEACHMODE)3

/*
 *  TEACHLOCK
 */
typedef unsigned long	TEACHLOCK;
#define LOCK_OFF    (TEACHLOCK)0
#define LOCK_ON     (TEACHLOCK)1

/*
 *  ܥɥ饤ФȤ̿
 */
typedef unsigned long	COMSTATUS;
#define STP_STATUS    (COMSTATUS)0
#define MOV_STATUS    (COMSTATUS)1
#define SIM_STATUS    (COMSTATUS)2

/*
 *
 */
#define	MOD_ROBFILE	1
#define	MOD_TOLFILE	2

/*
 *	ݥӥ󥰤ȥǡݥ¤
 */
typedef struct {
	long	Enable;		/* ӥå 				*/
	float	_xyz[3];	/* ɸʬ̵եå 	*/
	float	Ixyz[3];	/* ɸʬͭꥪեå 	*/
	float	_XYZ[3];	/* ܥåȺɸʬ̵եå 	*/
	float	IXYZ[3];	/* ܥåȺɸʬͭꥪեå 	*/
	float	_wave[3];	/* ƻɸʬ̵եå 	*/
	float	Iwave[3];	/* ƻɸʬͭꥪեå 	*/
} TRANSMAT, *TRANSMATP;

/* 
 * ɸͤι¤ 
 */
typedef struct {
	ANGLE		angle;
	MATRIX		noap;
	float		ypr[3];
} ARMTARGET, *ARMTARGETP;

typedef struct {
	long	sig;
	long	trq;
	long	vel;
} O8DRIVE;
typedef struct {
	long	sts;
	long	agl;
	long	vel;
	long	trq;
} I8DRIVE;

/*
	ǥåɥޥ󥹥å
*/
#define SET_DDM	3


/*
	CUBE¤
*/
typedef struct{
	long	ena;
	long	mod;
	float	max[3];
	float	min[3];
	char	cmt[32];
} CUBE, *CUBEP;


/* 
 * ǥХå¤
 */
typedef struct {
	long	ldbg[16];
	float	fdbg[32];
} DEBG, *DEBGP;

/*===========================================================================
	ؿΥץȥ
===========================================================================*/
#define	DllExport	
#define	__stdcall	

#ifdef __cplusplus
extern  "C" {
#endif


/*
 *	ؿ
 */
DllExport long __stdcall pa_ini_sys(void);/* PA 饤֥ν	*/
DllExport long __stdcall pa_ter_sys(void);/* PA 饤֥νλ	*/

/*
 *	ưؿ
 */

DllExport long __stdcall pa_opn_arm(ARM);	/* Υץ	*/
DllExport long __stdcall pa_con_arm(ARM,char*);	/* Υץ	*/
DllExport long __stdcall pa_cls_arm(ARM);	/* Υ	*/

DllExport long __stdcall pa_sta_arm(ARM);	/* 		*/
DllExport long __stdcall pa_ext_arm(ARM);	/* λ			*/

DllExport long __stdcall pa_stp_arm(ARM,long);	/* 			*/
DllExport long __stdcall pa_sus_arm(ARM,long);	/* 		*/
DllExport long __stdcall pa_rsm_arm(ARM,long);	/* Ƴ			*/

DllExport long __stdcall pa_exe_axs(ARM,AXIS,ANGLEP,long);/* Ƽư	*/
DllExport long __stdcall pa_exe_edr(ARM,AXIS,ANGLEP,long);/* ѵư	*/

DllExport long __stdcall pa_exe_hom(ARM,long);	/* ܻư		*/
DllExport long __stdcall pa_exe_esc(ARM,long);	/* ư		*/
DllExport long __stdcall pa_exe_saf(ARM,long);	/* ư		*/

DllExport long __stdcall pa_mov_XYZ(ARM,float,float,float,long);
DllExport long __stdcall pa_mov_YPR(ARM,float,float,float,long);
DllExport long __stdcall pa_mov_xyz(ARM,float,float,float,long);
DllExport long __stdcall pa_mov_ypr(ARM,float,float,float,long);

DllExport long __stdcall pa_mov_mat(ARM,MOVEMODE,MATRIX,ANGLEP,long);

/*
 *	˴ؤؿ/ץ쥤Хå˴ؤؿ
 */
DllExport long __stdcall pa_chg_pnt(ARM,PNTMOVE,long);
DllExport long __stdcall pa_add_pnt(ARM,PNTTYPE);
DllExport long __stdcall pa_del_pnt(ARM,PNTDEL);
DllExport long __stdcall pa_rpl_pnt(ARM);
/*°ѹ	PCIǲ¤	*/
DllExport long __stdcall pa_set_pnt(ARM,PNTATTR,long*,float);

DllExport long __stdcall pa_mov_pnt(ARM,long);
/*ץ쥤Хå		PCIǲ¤	*/
DllExport long __stdcall pa_ply_pnt(ARM,PLAYBACK,long,long);	
/*ǡ	PCIǲ¤	*/
DllExport long __stdcall pa_lod_pnt(ARM,long,char *);
DllExport long __stdcall pa_sav_pnt(ARM,char *);

DllExport long __stdcall pa_vel_pnt(ARM,float);	/* ץ쥤Хå®ٷ	*/

/*
 *	®⡼ɤ˴ؤؿ
 */
DllExport long __stdcall pa_mod_vel(ARM,VELMODE,AXIS);	/* Ver.1.3ǲ¤ */
DllExport long __stdcall pa_odr_vel(ARM,float[]);	/* Ver.1.3ǲ¤ */

/*
 *	Ĺ
 */
DllExport long __stdcall pa_mod_jou(ARM,JOUMODE);
DllExport long __stdcall pa_odr_jou(ARM,JOUTYPE);

/*
 *	üа֡ؿ
 */
DllExport long __stdcall pa_mod_dpd(ARM);
DllExport long __stdcall pa_odr_dpd(ARM,MATRIX,ANGLEP);

/*
 *	쥯ؿ
 */
DllExport long __stdcall pa_wet_ded(ARM,AXIS);
DllExport long __stdcall pa_get_amp(ARM);
DllExport long __stdcall pa_mod_dir(ARM,DIRECTMODE);

/*
 *	˴ؤؿ
 */
DllExport long __stdcall pa_set_hom(ARM,ANGLEP);
DllExport long __stdcall pa_set_esc(ARM,ANGLEP);
DllExport long __stdcall pa_set_saf(ARM,ANGLEP);

DllExport long __stdcall pa_def_hom(ARM);
DllExport long __stdcall pa_def_esc(ARM);
DllExport long __stdcall pa_def_saf(ARM);

/*
 *	ɸѴ˴ؤؿ
 */
DllExport long __stdcall pa_set_mtx(ARM,MATRIX);

/*
 *	Υơɤ߹ؿ
 */
DllExport long __stdcall pa_get_sts(ARM,ARMSTATUSP);
DllExport long __stdcall pa_get_cnt(ARM,long*);
DllExport long __stdcall pa_get_err(ARM,long*);
DllExport long __stdcall pa_get_agl(ARM,ANGLEP);
DllExport long __stdcall pa_get_xyz(ARM,VECTOR);
DllExport long __stdcall pa_get_noa(ARM,MATRIX);
DllExport long __stdcall pa_get_ypr(ARM,VECTOR);
DllExport long __stdcall pa_get_prm(ARM,PARAMP);
DllExport long __stdcall pa_get_pnt(ARM,PNTDATP);
DllExport long __stdcall pa_get_cur(ARM,long*);
DllExport long __stdcall pa_get_num(ARM,long*);
DllExport long __stdcall pa_get_lvl(ARM,long,long*);
DllExport long __stdcall pa_get_fvl(ARM,long,float*);

/*
 *	ǥϤ˴ؤؿ	PCIǲ¤
 */
DllExport long __stdcall pa_inp_dio(ARM,DIOKIND,DIOSTATUSP);
DllExport long __stdcall pa_oup_dio(ARM,DIOKIND,DIOSTATUSP);
DllExport long __stdcall pa_get_dio(ARM,DIOKIND,DIOPORT,DIOCH,unsigned char*);
DllExport long __stdcall pa_set_dio(ARM,DIOKIND,DIOPORT,DIOCH);
DllExport long __stdcall pa_rst_dio(ARM,DIOKIND,DIOPORT,DIOCH);

/*
 *	ѥ᡼˴ؤؿ
 */
/* ѹ	*/
DllExport long __stdcall pa_set_tol(ARM,float,float,float,float);
/* ǥե®٤ѹ 	*/
DllExport long __stdcall pa_set_vel(ARM,VELTYPE,float*);

/* ưCPUإѥ᡼Υ 	*/
DllExport long __stdcall pa_lod_ctl(ARM,char *);
/* ưCPUΥѥ᡼- 	*/
DllExport long __stdcall pa_sav_ctl(ARM,char *);		

DllExport long __stdcall pa_lod_def(ARM);/* ưCPUѥ᡼*/
DllExport long __stdcall pa_sav_def(ARM);/* ưCPUѥ᡼- */

/*
 *	¾δؿ
 */
DllExport long __stdcall pa_map_ctl(ARM);				/* 楳ȥζͭΰޥåԥ	*/
DllExport short __stdcall pa_fsh_chk(ARM);				/* 楳ޥɤνλλԤ	*/
DllExport long __stdcall pa_req_ctl(ARM,long);			/* 楳ȥ˥ޥ*/
DllExport long __stdcall pa_rst_ctl(ARM);				/* Υ顼ꥻå			*/

DllExport long __stdcall	pa_err_mes(long,char*);		/* 顼å		*/

/*======== Ver. 1.3 ɲåǡݥס ========*/
/*
 *	ؿ
 */
DllExport long __stdcall pa_sta_sim(ARM);				/* ߥ-󥹥			*/
DllExport long __stdcall pa_ext_sim(ARM);				/* ߥ-λ			*/

/*
 *	ǥϤ˴ؤؿ
 */
DllExport long __stdcall pa_swt_dio(ARM,long);
DllExport long __stdcall pa_chg_dio(ARM,DIOSTATUSP);	/* Σģϥ-°ؿ */
/*
 *	ץ쥤Хå˴ؤؿ
 */
DllExport long __stdcall pa_set_idn(ARM,PNTID,long);	/* ɣؿ	*/
DllExport long __stdcall pa_get_idn(ARM,long*);			/* ɣĻȴؿ	*/
DllExport long __stdcall pa_axs_pnt(ARM,long);			/* Ƽǥץ쥤Хóذư*/
DllExport long __stdcall pa_set_dlc(ARM,long);			/* ץ쥤ХåDOμưߤ 	*/
DllExport long __stdcall pa_get_dlc(ARM,long*);			/* ץ쥤ХåDOμưߤμ 	*/

/*
 *	ݥӥ˴ؤؿ
 */
DllExport long __stdcall   pa_odr_xyz(ARM,TRANSMATP);	/* ˴ؤؿ  */
DllExport long __stdcall   pa_lmt_xyz(ARM,float);		/* եå­ߤΥߥåк */
DllExport long __stdcall   pa_get_lmt(ARM,float*);		/* üեåͤΥߥåͤ*/
DllExport short __stdcall pa_fsh_sub(ARM);				/* 楳ޥɤνλλԤ*/
DllExport long __stdcall   pa_req_sub(ARM,long);		/* 楳ȥ˥ޥ*/

/*
 *	ɸѴ˴ؤؿ
 */
DllExport long __stdcall pa_set_mat(ARM,MATRIX,MATRIX);

/*
 *	쥯ؿ
 */
DllExport long __stdcall pa_drt_ded(ARM,long);			/* -οդ	*/
DllExport long __stdcall pa_chk_cnt(ARM);				/* Ƽ-ɤƱ 	*/
DllExport long __stdcall pa_set_tim(ARM,long);			/* ॢȻ  		*/

/*
 *	Υơɤ߹ؿ
 */
DllExport long __stdcall pa_get_mod(ARM,long*);			/* ưΥ-  	*/
DllExport long __stdcall pa_get_jou(ARM,long*);			/* RMRCĹ-ɼ */
DllExport long __stdcall pa_get_ver(ARM,float*);		/* ưVer.   	*/
DllExport long __stdcall pa_get_pvl(ARM,float*);		/* ץ쥤Хå   	*/
DllExport long __stdcall pa_get_pdo(ARM,long*);			/* ץ쥤ХåDIO   	*/
DllExport long __stdcall pa_get_cpt(ARM,PNTNO,PNTDATP);	/* ߡ߸̥- 	*/
DllExport long __stdcall pa_get_mat(ARM,MATRIX,MATRIX);	/* ɸѴ 	*/
DllExport long __stdcall pa_get_sns(ARM,TRANSMATP);		/* 󥵾		*/
DllExport long __stdcall pa_get_tar(ARM,ARMTARGETP);	/* ɸ;		*/
DllExport long __stdcall pa_get_com(ARM,long*);			/* ֤̿μ   	*/
DllExport long __stdcall pa_get_tim(ARM,long*);			/* ॢȻ֤μ 	*/
DllExport long __stdcall pa_get_drt(ARM,long*);			/* ޥ־֤μ	*/

/*
 *	ӣгٻˤĹưؿ
 */
DllExport long __stdcall pa_mov_jou(ARM,float,long);			/* Ĺ 	*/
/*
 *	Ƽꥢݥɤ˴ؤؿ
 */
DllExport long __stdcall pa_mod_axs(ARM);						/* Ƽꥢ- 	*/
DllExport long __stdcall pa_odr_axs(ARM,ANGLEP);				/* Ƽꥢ- 	*/



/*======== PCI- ɲåǡݥ	 ========*/
DllExport long __stdcall pa_ply_set(ARM,long,long*);			/* ֹ椷Ƥˤ궵ǡKey 	*/
DllExport long __stdcall pa_act_pnt(ARM,long);					/* ƥ֤ʶǡڴ 	*/
DllExport long __stdcall pa_jmp_set(ARM,long,long,JUMPP);		/* ֹˤJUMP 	*/
DllExport long __stdcall pa_get_jmp(ARM,long,long,JUMPP);		/* Key/IDˤJUMP 	*/
DllExport long __stdcall pa_set_jmp(ARM,long,long,JUMPP);		/* JUMP 	*/
DllExport long __stdcall pa_ena_jmp(ARM,long);					/* JUMPͭ/̵ 	*/
DllExport long __stdcall pa_ply_mod(ARM,long);					/* ⡼ 	*/
DllExport long __stdcall pa_set_cub(ARM,long,float[],float[]);	/* CUBEλ 	*/
DllExport long __stdcall pa_get_cub(ARM,long,long);				/* CUBEζ 	*/
DllExport long __stdcall pa_cub_len(ARM,long,float[]);			/* CUBEĹ 	*/
DllExport long __stdcall pa_cub_cmt(ARM,long,char*);			/* CUBE̾Ĥ 	*/
DllExport long __stdcall pa_del_cub(ARM,long);					/* CUBEκ 	*/
DllExport long __stdcall pa_ena_cub(ARM,long,long);				/* CUBEͭ/̵ 	*/
DllExport long __stdcall pa_inf_cub(ARM,long,CUBEP);			/* CUBEξ󻲾 	*/
DllExport long __stdcall pa_get_prj(ARM,char*);					/* ץ̾ 	*/
DllExport long __stdcall pa_set_prj(ARM,char*);					/* ץ̾ 	*/
DllExport long __stdcall pa_sav_prj(ARM,char*);					/* ץȤΥ 	*/
DllExport long __stdcall pa_lod_prj(ARM,char*);					/* ץȤΥ 	*/
DllExport long __stdcall pa_get_sav(ARM,long*);					/* ܥƥ 	*/
DllExport long __stdcall pa_chg_key(ARM,long);					/* ߥƥ֤ʶǡKeyѹ 	*/
DllExport long __stdcall pa_get_key(ARM,long*);					/* ߥƥ֤ʶǡKey 	*/
DllExport long __stdcall pa_mon_pnt(ARM,PNTDATP);				/* ǡξ֤˥뤿˼ 	*/
DllExport long __stdcall pa_sav_sts(ARM,long[]);				/* ܥƥ */
DllExport long __stdcall pa_set_cmt(ARM,char*);					/*  */
DllExport long __stdcall pa_tst_nom(ARM,long);					/* RETRACON/OFF */
DllExport long __stdcall pa_get_rmd(ARM,long*);					/* RETRACON/OFF */
DllExport long __stdcall pa_dio_msk(ARM,long,long,long);		/* DIO mask */
DllExport long __stdcall pa_get_msk(ARM,long,long,long*);		/* DIO mask */
DllExport long __stdcall pa_jmp_cmt(ARM,long,char*);			/* ȤˤꥫȥݥȰư */
DllExport long __stdcall pa_get_ena(ARM,long*);					/* JUMPͭ/̵    */
DllExport long __stdcall pa_get_pmd(ARM,long*);					/* ⡼ɼ     */	
DllExport long __stdcall pa_sav_ptj(ARM,char*);					/* ǡJUMP򥻡֤   */
DllExport long __stdcall pa_lod_ptj(ARM,char*);					/* ǡJUMPɤ   */
DllExport long __stdcall pa_get_dbg(ARM,DEBGP);					/* ǥХå */
DllExport long __stdcall pa_set_ddm(ARM,long,long);				/* ǥåɥޥSWͭ/̵ */
DllExport long __stdcall pa_get_ddm(ARM,long,long*);			/* ǥåɥޥSWͭ/̵ּ */
DllExport long __stdcall pa_del_jmp(ARM,long,long);				/* JUMP */
DllExport long __stdcall pa_set_lok(ARM,long);					/* TEACHLOCK */
DllExport long __stdcall pa_get_lok(ARM,long*);					/* TEACHLOCK */
DllExport long __stdcall pa_tct_tim(ARM,long*);					/* ȥʥץ쥤Хå֡˼ */
DllExport long __stdcall pa_get_smd(ARM,long*);					/* ܤTEACHMODE */
DllExport long __stdcall pa_get_max(ARM,long*);					/* ܡɤǽ */
DllExport long __stdcall pa_get_spt(ARM,long*);					/* Ȥܤˤ뤫 */




/*======== 486- ɲåǡݥ	H8.4.12 ========*/
/*======== ISA-бѤѹ		H9.7.18 ========*/
/*
 *	¾δؿ pa_mem.c
 */
DllExport long __stdcall pa_mem_cpy(long,void*,void*,size_t,int);/* 1Хñ̤Υꥳ-	*/
DllExport long __stdcall pa_mem_blk(long,void*,void*,size_t,int);/* 1Хñ̤Υꥳ-	*/
DllExport long __stdcall pa_cpy_flt(long,void*,void*,int);	/* float1Хñ̤Υꥳ-	*/
DllExport long __stdcall pa_cpy_lng(long,void*,void*,int);	/* long1Хñ̤Υꥳ-	*/
DllExport long __stdcall pa_cpy_uby(long,void*,void*,int);	/* unsigned char1Хñ̤Υꥳ-*/
DllExport long __stdcall pa_ret_lng(long,void*);				/* long1Хñ̤Υꥳ-	*/
/* pa_egt.c */
DllExport long __stdcall	pa_get_lgh(ARM,float*);			/* S2-W2ֵΥͼ	*/

DllExport long __stdcall WinLANinit(long,char*);
DllExport long __stdcall WinLANabort(long);

DllExport long __stdcall WinRTinit(long);
DllExport long __stdcall WinRTabort(long);
DllExport long __stdcall MakeMutex(long);
DllExport long __stdcall DestroyMutex(long);
DllExport long __stdcall LockMutex(long);
DllExport long __stdcall UnlockMutex(long);

DllExport long __stdcall pa_set_sim(ARM, long);
DllExport long __stdcall pa_set_inc(ARM, float);
DllExport long __stdcall pa_get_sim(ARM, long*);
DllExport long __stdcall pa_get_inc(ARM, float*);
DllExport long __stdcall pa_lod_rob(ARM armno,char *file);
DllExport long __stdcall pa_lod_tol(ARM armno,char *file);
DllExport long __stdcall pa_sav_rob(ARM armno);
DllExport long __stdcall pa_ena_nom(ARM armno,long sw);
DllExport long __stdcall pa_ini_axs(ARM,AXIS,ANGLEP,long);/* */
DllExport long __stdcall pa_get_nom(ARM armno,long *rpm);



#ifdef __cplusplus
}
#endif


#endif	/* _PA_H_	*/



