#ifndef _PACTL_H
#define	_PACTL_H

#define	EPDATA			16
#define	AXISNUMBER		7
#define	VECTNUMBER		6
#define	COORDNUMBER		3
#define	DATABLOCKNUMBER	5
#define	ARCNETPACET		256

/*
	Communication Header Discription
*/
typedef struct {
	long	com;			/* ̿ݥ	*/
	long	evt;			/* ٥		*/
	long	sts;			/* 			*/
	long	mod[4];			/* ưݥ*/
	long	dmy[8];			/* ͽ			*/
} HED;
/*
	High Lank Controller Communication structure (UP) 
*/
typedef struct {
	long	axs;					/* ѿ*/
	float	agl[AXISNUMBER];		/* ɸ		*/
	float	xyz[COORDNUMBER];		/* ɸ		*/
	float	ypr[COORDNUMBER];		/* ɸ		*/
	long	lvl;					/* ץ쥤Хå®*/
	float	fvl;
} DWN;
/*
	Robot OutPut Data structure
*/
typedef struct {
	long	brk;					/* ֥ݥ ON/OFF*/
	long	sav;					/* ݥ ON/OFF*/
	long	vts;					/* ®١ȥ륯*/
	long	trq[AXISNUMBER];		/* ȥ륯*/
	long	vel[AXISNUMBER];		/* ®ٻ*/
	long	dmy[AXISNUMBER];		/* ͽ*/
} ODT;
/*
	Robot InPut Data structure
*/
typedef struct {
	long	rez[AXISNUMBER];	/* 쥾*/
	long	trq[AXISNUMBER];	/* ȥ륯*/
	long	sts[AXISNUMBER*2];	/* ݥܥơݥ*/
	long	dmy[AXISNUMBER];	/* ͽ*/
} IDT;
/*
	Target [N,O,A,P] structure
*/
typedef struct {
	float	agl[AXISNUMBER];		/* Ƽ(١®)ɸ*/
	float	xyz[COORDNUMBER];		/* ɸ*/
	float	noa[COORDNUMBER][COORDNUMBER];	/* ɸ */
	float	fce[VECTNUMBER];		/* ɸ*/
} TGT;
/*
	Mark [N,O,A,P] structure
*/
typedef struct {
	float	agl[AXISNUMBER];		/* Ƽ(١®)*/
	float	xyz[COORDNUMBER];		/* ָ*/
	float	noa[COORDNUMBER][COORDNUMBER];	/* */
	float	fce[VECTNUMBER];
} MRK;
/*
	Error note structure
*/
typedef struct {
/*
	long	wrn[AXISNUMBER];
	long	err[AXISNUMBER];
*/
	long	dmy[16];
	long	drv[8];
} ERR;
/*
	Parameter structure
*/
typedef struct {
	float	pul[AXISNUMBER];	/* ֥ߥåʡܡ*/
	float	pdl[AXISNUMBER];	/* ֥ߥåʡݡ*/
	float	vel[AXISNUMBER + 2];/* ®٥ߥå*/
	float	dev[AXISNUMBER + 2];/* ǥե®*/
	float	lim[AXISNUMBER + 2];/* */
	float	ceh[AXISNUMBER + 2];/* */
	float	cem[AXISNUMBER + 2];/* */
	float	cel[AXISNUMBER + 2];/* */
	float	pg1[AXISNUMBER];	/* 楲*/
	float	pg2[AXISNUMBER];	/* 楲*/
	float	vg1[AXISNUMBER];	/* ®楲*/
	float	tg1[AXISNUMBER];	/* 楲*/
	float	pcm[AXISNUMBER];	/*  	!!*/
	float	fcm[AXISNUMBER];	/*    	!!*/
	float	arl[AXISNUMBER];	/* ݥĹ*/
	float	arg[AXISNUMBER];	/* Ƽſ*/
	float	arw[AXISNUMBER];	/* Ƽ*/
	float	hom[AXISNUMBER];	/* ܻɸ */
	float	saf[AXISNUMBER];	/* ¾ɸ*/
	float	esc[AXISNUMBER];	/* ɸ*/
	float	tol[AXISNUMBER];	/* ѥݥ*/
	float	fvl[AXISNUMBER];	/* */
	long	dmy[AXISNUMBER];	/* ӥ󥰥ѥ᡼*/
	long	spa[AXISNUMBER];	/* ͽ			!!*/
} PRM;
/*
	Arcnet transform structure
*/
typedef struct {
	unsigned char pkt[256];	/* ܥɥ饤̿ѥå*/
} BSE;

typedef struct {
	long	Enable;			/* ӥå */
	float	_xyz[3];		/* ɸʬ̵եå */
	float	Ixyz[3];		/* ɸʬͭꥪեå */
	float	_XYZ[3];		/* ܥåȺɸʬ̵եå */
	float	IXYZ[3];		/* ܥåȺɸʬͭꥪեå */
	float	_wave[3];		/* ƻɸʬ̵եå */
	float	Iwave[3];		/* ƻɸʬͭꥪեå */
} TRN;

/*
	standard & extend digital I/O
	[0]:standard digital I/O
	[1]:extend digital I/O
*/
typedef struct {
	unsigned long	imask[2];
	unsigned long	omask[2];	
	unsigned long	i1420[2];	/* ǥ*/
	unsigned long	o1420[2];	/* ǥ*/
	unsigned long	x1420[2];	/* ǥ Ver.1.3*/
} DIO;
/*
	debug monitor
*/
//typedef struct {
//	long	L[14];			/* 󥰥ǡǥХåꥢ*/
//	float	F[14];
//} DBG;
/*
	386 - 486 communication flag
*/
typedef struct {
	long	flag[7];		/* ̿ѥե饰*/
} FLG;
/*
	x, y, z, y, p, r
*/
typedef struct {
	float	max[7];	/* Ƽ [rad] */
	float	tax[7];	/* Ƽ ɸ[rad] */
	float	mrk[6]; /* ܥåȺɸ & */
	float	tgt[6];	/* ܥåȺɸ & ɸ*/
	float	len[7];	/* S2W2ޤǤμֵΥ[0] */
} YPR;
/*
	Teaching data structure Parts
*/
/*
typedef struct {
	long	BlockNum;
	long	BlockCount;
//	long	TeachData[DATABLOCKNUMBER][EPDATA];
	float	TeachData[DATABLOCKNUMBER][EPDATA];
} TEACH;
*/
/*
	arm constant data
*/
typedef struct {
	float	agl[7];
	float	vel[2];
	long	atr[12];
} PNT;
typedef struct {
	PNT		pnt;
	char	cmt[32];
} PLY;
/*

*/
typedef struct {
	float	xyz[3];
	float	noa[3][3];
} NOA;
/*

*/
typedef struct {
	long	cnd[2];
	long	xdi;
	long	tim;
	long	key;
	long	pid;
	long	cnt;
} JDG;
typedef struct {
	long	cid;
	JDG		jdg[8];
} JMP;
/*
	CUBE
*/
typedef struct{
	long	ena;
	long	mod;
	float	max[3];
	float	min[3];
	char	cmt[32];
} CUB;
/*

*/
typedef struct{
	long	max;
	long	arm;
	long	axs;
	long	typ;
	long	drv;
	long	dio;
	float	ver;		/* version	*/
	float	rtv[7];		/* 쥾Ѵ 			*/
	float	len[8];		/* [0]-[6]-Ĺ [7]RMRC³Ĺ */
/*	float	spa[7];	*/	/* [0]Ʊ [1]-[6]ͽ 	*/
}ARD;
/*


  */
typedef struct {
	long	lvl[16];
	float	fvl[16];
}GET;

typedef struct{
	long	lvl[16];
	PLY		ply;
	NOA		noa;
	JMP		jmp;
}STS;

typedef struct {
	long	lvl[16];
	float	fvl[32];
}DBG;

/*-----------------------------------------------------------------------------
		 ѥ᡼
-----------------------------------------------------------------------------*/
typedef struct {
	float	SNS[6];
	float	TOG[6];
	float	XCE[6][6];
	float	XCI[6][6];
	float	VEC[3][3];
	float	MU1[6];
	float	MU2[6];
	float	MD1[6];
	float	MD2[6];
	float	FGR[6];
	float	FGH[6];
	float	V2N[6];
	float	DEV[6];
	float	SP1[6];
	float	SP2[6];
	float	DMY[6];
} D_FPARAMETER;

/*---------------------------------------------------------------------------
	 
----------------------------------------------------------------------------*/
typedef struct {
	float	PMX[6];
	float	FMX[6];
} D_PFMAT;

typedef struct {
	long	Coord;
	float	Force[6];
	long	Fdata;
} D_FDOWN;

typedef struct {
	float	ORGforce[6];
	float	OFFforce[6];
	float	XCEforce[6];
	float	TGTforce[6];
	float	XCIforce[6];
} D_FORCE;

typedef struct {
	long	state[256];
} M_STATE;

typedef struct {
	long	Switch[2];
	long	DeadMain[2];
	long	DoLine[2];
	long	InterLock[2];
} M_TERM;

typedef struct {
	long	control;
	long	vcltrol;
	long	cbltrol;
	long	ack;
	long	err;
} M_ASPECT;
typedef struct {
	short	sig;
	short	trq;
	short	vel;
} O8_DRIVER;
typedef struct {
	short	sts;
	char	agl[4];
	short	vel;
	short	trq;
} I8_DRIVER;
typedef struct {
	long	no;
	long	ev;
	long	en7;
	long	en8;
	O8DRIVE	o7;
	O8DRIVE	o8;
	long	sdo;

	I8DRIVE	i7;
	I8DRIVE	i8;
	long	sdi;		/* 8ch */
	long	sai[4];		/* 10bit data */
	M_ASPECT	aspect;	
} GTE;

/*-----------------------------------------------------------------------------
		For 386 Communication format
-----------------------------------------------------------------------------*/
/*
	command area
*/
typedef struct {
	HED			hed;
	DWN			dwn;			/* 386ǡ			(1)*/
	PLY			ply;			/* ǡ				(3)*/
	NOA			noa;
	JMP			jmp;
	BSE			bse;		/* ܥɥ饤ѥǡ		(4)*/
	PRM			prm;		/* ѥ᡼ơ֥			(5)*/
	MRK			wrk[2];		/* ɸѴ			(6)*/
	MRK			mat;			/* J/Sprm 	(7)	//noap	(8)*/
	TRN			trn;		/* ӥ󥰡󥵡etcǡ				*/
	DIO			dio;
	GTE			gte;
} HDN;

typedef struct {
	D_FPARAMETER	fprm;		/* ѥ᡼							*/
	D_FDOWN			fdown;		/*  							*/
	D_PFMAT			pfmat;		/* ֤Ϥ					*/
} FDN;
typedef struct {
	D_FPARAMETER	fprm;		/* ѥ᡼							*/
	D_FORCE			force;		/* ϥϥ- 	*/
} FUP;
/*-----------------------------------------------------------------------------
		For 386 Communication format
-----------------------------------------------------------------------------*/
/*
	answer area
*/
typedef struct {			/* ROBOTϥǡݥ*/
	IDT		idt;
	ODT		odt;
} RIO;
typedef struct {			/* ͡ڤӡɸ*/
	MRK		mrk;
	TGT		tgt;
} POS;
typedef struct {
	HED			hed;
	RIO			rio;		/* ܥå̿ǡ*/
	POS			pos;		/* &ɸ*/
	MRK			mat[2];
	TRN			trn;		/* ӥ󥰡󥵡etcûǡ			*/
	PLY			ply;
	NOA			noa;
	JMP			jmp;
	BSE			bse;		/* ܥɥ饤Хǡ*/
	PRM			prm;		/* ѥ᡼ơ֥			(5)*/
	ERR			err;		/* 顼åꥢ*/
	DIO			dio;		/* ɸ*/
	FLG			flg;		/* 386ѥե饰*/
	YPR			ypr;		/* -฽&ɸ(ޥޥ󥳥ȥ-黲Ȥ) */
	CUB			cub;		/* CUBE */
	ARD			ard;
	GET			get;
	STS			sts;
	DBG			dbg;
} HUP;

/*---------------------------------------------------------------------------
	COMINUCATION MAP.(楳ȥ-ȥޥޥ󥳥ȥ-ζͭꥢ)
----------------------------------------------------------------------------*/
typedef struct {
	HDN				hd;			/* ޥޥ󥳥ȥ- -> 楳ȥ- ̿ꥢ 	*/
	FDN				fd;
	HUP				hu;			/* ޥޥ󥳥ȥ- <- 楳ȥ- ̿ꥢ 	*/
	FUP				fu;
}COMUNI, *COMUNIptr;

/*



*/
typedef struct {
	HDN				hd;			/* ޥޥ󥳥ȥ- -> 楳ȥ- ̿ꥢ 	*/
	FDN				fd;
	HUP				hu;			/* ޥޥ󥳥ȥ- <- 楳ȥ- ̿ꥢ 	*/
	FUP				fu;
}COMCOMX;

#endif



