/*


	PAlib digital I/O function


*/
#include	<stdio.h>
#include	<stdlib.h>

#include	<pa.h>
#include	<pacmd.h>
#include	<pactl.h>
#include	<pammc.h>
#include	<paerr.h>

/******************************************************************
	ި
			armno		No.
			dk		ܡɤμ
			ds		

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_inp_dio(ARM armno, DIOKIND dk, DIOSTATUSP ds)
{
	long	st;

	if(ERR_OK!=(st=pa_map_ctl(armno)))	return st;
	if(ERR_OK!=(st=pa_mem_cpy((long)armno,ds,&(_comuni->hu.dio.i1420[dk]),sizeof(DIOSTATUS),1)))	return(st);
	return pam_get_err(armno);
}

/******************************************************************
	ǥ 
			armno		No.
			dk		ܡɤμ
			ds		

			ERR_OK			ｪλ
			ERR_ARM			No.ְäƤ.
			ERR_INT			ߤʤä.
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_oup_dio(ARM armno, DIOKIND dk, DIOSTATUSP ds)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	EV_SET_DIO;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	st=pa_mem_cpy(	(long)armno,&(_comuni->hd.dio.o1420[dk]),ds,sizeof(DIOSTATUS),2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_sub(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}
/******************************************************************
	ǥ ch. 
			armno			No.
			dk			ܡɤμ
			dp			ǥport
			dc			ǥchannal
			byte			ϥǡ

			ERR_OK			ｪλ
			ERR_ARM			No.ְäƤ.
			ERR_INT			ߤʤä.
			ERR_DP			ݡֹ椬ְäƤ
			ERR_DC			ֹͥ椬ְäƤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_get_dio(ARM armno, DIOKIND dk, DIOPORT dp, DIOCH dc, unsigned char* byte)
{
	unsigned char 	*p,bit;
	DIOSTATUS		ds;
	long			st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )		return st;
	if( dc<DC_CH1 || dc>DC_CH8 )			return ERR_DC;
	if( dk!=DIO_INTERNAL && dk!=DIO_EXTERNAL )	return ERR_BOARD;

	switch(dp){
	case DP_PORT1:
	case DP_PORT2:
	case DP_PORT3:
	case DP_PORT4:
		if(ERR_OK!=(st=pa_mem_cpy((long)armno,&ds,
			(void*)&_comuni->hu.dio.i1420[dk],sizeof(DIOSTATUS),1)))	return(st);
		p=(unsigned char*)&ds;
		bit=(unsigned char)(1<<dc);
		bit &= p[dp];
		*byte=bit;
		return pam_get_err(armno);
	case DPO_PORT1:
	case DPO_PORT2:
	case DPO_PORT3:
	case DPO_PORT4:
		if(ERR_OK!=(st=pa_mem_cpy((long)armno,(void*)&ds,
			(void*)&_comuni->hu.dio.o1420[dk],sizeof(DIOSTATUS),1)))	return(st);
		p=(unsigned char*)&ds;
		bit=(unsigned char)(1<<dc);
		bit &= p[dp-4];
		*byte=bit;
		return pam_get_err(armno);
	case DPX_PORT1:
	case DPX_PORT2:
	case DPX_PORT3:
	case DPX_PORT4:
		if(ERR_OK!=(st=pa_mem_cpy((long)armno,(void*)&ds,
			(void*)&_comuni->hu.dio.x1420[dk],sizeof(DIOSTATUS),1)))	return(st);
		p=(unsigned char*)&ds;
		bit=(unsigned char)(1<<dc);
		bit &= p[dp-8];
		*byte=bit;
		return pam_get_err(armno);
	default:
		return ERR_DP;
	}
}

/******************************************************************
	ǥ set 
			armno		No.
			dk		ܡɤμ
			dp		ǥݡ
			dc		ͥ

			ERR_OK			ｪλ
			ERR_ARM			No.ְäƤ.
			ERR_INT			ߤʤä.
			ERR_DP			ݡֹ椬ְäƤ
			ERR_DC			ֹͥ椬ְäƤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_set_dio(ARM armno, DIOKIND dk, DIOPORT dp, DIOCH dc)
{
	long			ldmy;
	unsigned char 	bit,*p;
	DIOSTATUS		ds;
	long			st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}
	ldmy = (long)	EV_SET_DIO;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	st=pa_mem_cpy(	(long)armno,(void*)&ds,
			(void*)&_comuni->hu.dio.o1420[dk],sizeof(DIOSTATUS),1);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	p=(unsigned char*)&ds;

	if( dc<DC_CH1 || dc>DC_CH8 ){
		UnlockMutex((long)armno);
		return ERR_DC;
	}
	if( dk!=DIO_INTERNAL && dk!=DIO_EXTERNAL ){
		UnlockMutex((long)armno);
		return ERR_BOARD;
	}
	
	switch(dp){
	case DP_PORT1:
	case DP_PORT2:
	case DP_PORT3:
	case DP_PORT4:
		bit=(unsigned char)(1<<dc);
		p[dp] |= bit;
		st=pa_mem_cpy((long)armno,(void*)&_comuni->hd.dio.o1420[dk],
					p,sizeof(DIOSTATUS),2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_sub(armno) );
		UnlockMutex((long)armno);
		return pam_get_err(armno);
	default:
		UnlockMutex((long)armno);
		return ERR_DP;
	}
}

/******************************************************************
	ǥ reset 
			armno		No.
			dk		ܡɤμ
			dp		ǥݡ
			dc		ǥͥ

			ERR_OK		ｪλ
			ERR_ARM		No.ְäƤ.
			ERR_INT		ߤʤä.
			ERR_DP		ݡֹ椬ְäƤ
			ERR_DC		ֹͥ椬ְäƤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_rst_dio(ARM armno, DIOKIND dk, DIOPORT dp, DIOCH dc)
{
	long			ldmy;
	unsigned char 	bit,*p;
	DIOSTATUS		ds;
	long			st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	ldmy = (long)	EV_SET_DIO;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}

	st=pa_mem_cpy(	(long)armno,(void*)&ds,
			(void*)&_comuni->hu.dio.o1420[dk],sizeof(DIOSTATUS),1);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	p=(unsigned char*)&ds;

	if( dc<DC_CH1 || dc>DC_CH8 ){
		UnlockMutex((long)armno);
		return ERR_DC;
	}
	if( dk!=DIO_INTERNAL && dk!=DIO_EXTERNAL ){
		UnlockMutex((long)armno);
		return ERR_BOARD;
	}
	switch(dp){
	case DP_PORT1:
	case DP_PORT2:
	case DP_PORT3:
	case DP_PORT4:
		bit=(unsigned char)(1<<dc);
		p[dp] &=~bit;
		st=pa_mem_cpy((long)armno,
		(void*)&_comuni->hd.dio.o1420[dk],p,sizeof(DIOSTATUS),2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
			UnlockMutex((long)armno);
			return st;
		}
		while( pa_fsh_sub(armno) );
		UnlockMutex((long)armno);
		return pam_get_err(armno);
	default:
		UnlockMutex((long)armno);
		return ERR_DP;
	}
}

/******************************************************************
	DIO ޥ
			armno	No.
			dio	DO or DI
			kind	ܡɤμ
			mask	ޥbitʥƥϲ8bitΤߡĥ32bit

			ERR_OK			ｪλ
			ERR_ARM			No.ְäƤ.
			ERR_INT			ߤʤä.
			ERR_BOARD		ܡֹ椬ְäƤ
			ERR_DIO			DIOְ꤬äƤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_dio_msk(ARM armno, long dio, long kind, long msk)
{
	long	ldmy;
	long	st;

	LockMutex((long)armno);
	if( ERR_OK!=(st=pa_map_ctl(armno)) ){
		UnlockMutex((long)armno);
		return st;
	}

	if( kind!=DIO_INTERNAL && kind!=DIO_EXTERNAL ){
		UnlockMutex((long)armno);
		return ERR_BOARD;
	}
	ldmy = (long)	1;
	st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.com),&ldmy,2);
	if(st<0){
		UnlockMutex((long)armno);
		return(st);
	}
	ldmy = (long)	msk;
	switch(dio){
	case DIMSK:
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dio.imask[kind]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		ldmy = (long)	EV_DIS_MSK;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		break;
	case DOMSK:
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.dio.omask[kind]),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		ldmy = (long)	EV_DOS_MSK;
		st=pa_cpy_lng(	(long)armno,&(_comuni->hd.hed.evt),&ldmy,2);
		if(st<0){
			UnlockMutex((long)armno);
			return(st);
		}
		break;
	default:
		UnlockMutex((long)armno);
		return ERR_DIO;
	}

	if( ERR_OK!=(st=pa_req_ctl(armno,RETRY_COUNT)) ){
		UnlockMutex((long)armno);
		return st;
	}
	while( pa_fsh_sub(armno) );
	UnlockMutex((long)armno);
	return pam_get_err(armno);
}

/******************************************************************
	DIO ޥ
			armno	No.
			dio	DO or DI
			kind	ܡɤμ
			mask	ޥbitʥƥϲ8bitΤߡĥ32bit

			ERR_OK			ｪλ
			ERR_ARM			No.ְäƤ.
			ERR_BOARD		ܡֹ椬ְäƤ
			ERR_DIO			DIOְ꤬äƤ
			ʾ¾फΥ顼ޤ
******************************************************************/
DllExport long __stdcall	pa_get_msk(ARM armno, long dio, long kind, long* msk)
{
	long	st;

	if( ERR_OK!=(st=pa_map_ctl(armno)) )		return st;
	if( kind!=DIO_INTERNAL && kind!=DIO_EXTERNAL )	return ERR_BOARD;

	switch(dio){
	case DIMSK:
		if(ERR_OK!=(st=pa_cpy_lng((long)armno,msk,&(_comuni->hu.dio.imask[kind]),1)))	return(st);
		break;
	case DOMSK:
		if(ERR_OK!=(st=pa_cpy_lng((long)armno,msk,&(_comuni->hu.dio.omask[kind]),1)))	return(st);
		break;
	default:
		return ERR_DIO;
	}
	return pam_get_err(armno);
}



