/*

	PAlib memory copy (float,long)function

*/
#include <sys/ioctl.h>
#include <stdio.h>
#include <fcntl.h>
#include <error.h>
#include <unistd.h>
#include <string.h>

#include	<pa.h>
#include	<pactl.h>
#include	<paerr.h>

#include	<papci.h>

#define	PAPCI_DEV	"/dev/papci"


#define	MAX_ARM	16				/*	486դ*/

#define	ARM0_FLG		0x0001
#define	ARM1_FLG		0x0002
#define	ARM2_FLG		0x0004
#define	ARM3_FLG		0x0008
#define	ARM4_FLG		0x0010
#define	ARM5_FLG		0x0020
#define	ARM6_FLG		0x0040
#define	ARM7_FLG		0x0080
#define	ARM8_FLG		0x0100
#define	ARM9_FLG		0x0200
#define	ARM10_FLG		0x0400
#define	ARM11_FLG		0x0800
#define	ARM12_FLG		0x1000
#define	ARM13_FLG		0x2000
#define	ARM14_FLG		0x4000
#define	ARM15_FLG		0x8000

#if 0
static	char	MUTEX_NAME[MAX_ARM][12]={	
		{"ArmMutex-00"},{"ArmMutex-00"},{"ArmMutex-02"},{"ArmMutex-00"},
		{"ArmMutex-04"},{"ArmMutex-04"},{"ArmMutex-06"},{"ArmMutex-06"},
		{"ArmMutex-08"},{"ArmMutex-08"},{"ArmMutex-10"},{"ArmMutex-10"},
		{"ArmMutex-12"},{"ArmMutex-12"},{"ArmMutex-14"},{"ArmMutex-14"}};
//static	HANDLE		__Mutex[MAX_ARM];
#endif

#define	INT_OFFSET	0x9e
#define	TAG_SIZE	0x2400

/*ưCPU  2PORT RAM ADD	*/
COMUNIptr _comuni = 0x00;

static int*	_486req;
extern int  	CtlPCI( int );

long _d14[MAX_ARM];
static long _d14_[MAX_ARM];

long _d3[MAX_ARM];
static long _d3_[MAX_ARM];

#ifdef win32
static	void	*__winRT2[MAX_ARM];
#endif

typedef unsigned char	DataType;

static	int	_dev_;

/******************************************************************/
/******************************************************************/
/******************************************************************/
DllExport long  MakeMutex(long arm)
{
/*
	__Mutex[arm]=CreateMutex(NULL,FALSE,MUTEX_NAME[arm]);
*/
	return(0);
}
/******************************************************************/
/******************************************************************/
/******************************************************************/
DllExport long  DestroyMutex(long arm)
{
/*
	CloseHandle(__Mutex[arm]);
*/
	return(0);
}
/******************************************************************/
/******************************************************************/
/******************************************************************/
DllExport long  LockMutex(long arm)
{
/*
	WaitForSingleObject(__Mutex[arm],INFINITE);
*/
	return(0);
}
/******************************************************************/
/******************************************************************/
/******************************************************************/
DllExport long  UnlockMutex(long arm)
{
/*
	ReleaseMutex(__Mutex[arm]);
*/
	return(0);
}

/******************************************************************
	WinRT Initialize
******************************************************************/
DllExport long  WinRTinit(long arm)
{
	_dev_=open(PAPCI_DEV,O_RDWR);
	return(_dev_);
}
/******************************************************************
	WinRT Close
******************************************************************/
DllExport long  WinRTabort(long arm)
{
	close(_dev_);
	return(0);
}
/******************************************************************

******************************************************************/
int	CtlPCI( int arm )
{
 	return(INT_OFFSET);
}
/******************************************************************

******************************************************************/
DllExport long  pa_mem_blk(long arm,void *dest,void *src,size_t n, int sw)
{
	DataType	*s=(DataType *)src;
	DataType	*d=(DataType *)dest;
	DataType	*dd=(DataType *)dest;
	unsigned int	ptr;
	PA_ARG		arg;

	arg.arm=arm/2;
	arg.size=n;

	arm=arm%2;
	switch(sw){
	case	1:	/* read */
		ptr=(unsigned int)s;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		ioctl(_dev_,PA_READ_PCI,&arg);
		memcpy((void*)dd,(void*)&arg.data[0],n);
		break;
	case	2:	/* write */
		ptr=(unsigned int)dd;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		memcpy((void*)&arg.data[0],(void*)s,n);
		ioctl(_dev_,PA_WRITE_PCI,&arg);
		break;
	case	3:	/* copy */
		ptr=(unsigned int)s;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		ioctl(_dev_,PA_READ_PCI,&arg);

		ptr=(unsigned int)d;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		ioctl(_dev_,PA_WRITE_PCI,&arg);
		break;
	}
	return(0);
}

/******************************************************************

******************************************************************/
static	 long  pa_cpy_4(long arm,void *dest,void *src, int sw)
{
	int		i;
	DataType	*s=(DataType *)src;
	DataType	*d=(DataType *)dest;
	DataType	*dd=(DataType *)dest;
	unsigned int	ptr;
	PA_ARG		arg;

	arg.arm=arm/2;
	arg.size=sizeof(float);

	arm=arm%2;
	switch(sw){
	case	1:	/* read */
		ptr=(unsigned int)s;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		ioctl(_dev_,PA_READ_PCI,&arg);
		/* swap */
		for(i=0;i<sizeof(float);i++){
			*dd=arg.data[sizeof(float)-(i+1)];
			dd++;
		}
		break;
	case	2:	/* write */
		ptr=(unsigned int)dd;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		/* swap */
		for(i=0;i<sizeof(float);i++){
			arg.data[sizeof(float)-(i+1)]=*s;
			s++;
		}
		ioctl(_dev_,PA_WRITE_PCI,&arg);
		break;
	case	3:	/* copy */
		ptr=(unsigned int)s;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		ioctl(_dev_,PA_READ_PCI,&arg);

		ptr=(unsigned int)d;
		arg.addr=(unsigned long)(arm*TAG_SIZE + ptr);
		ioctl(_dev_,PA_WRITE_PCI,&arg);
		break;
	}
	return(0);
}
/******************************************************************

******************************************************************/
DllExport long  pa_mem_cpy(long arm,void *dest,void *src,size_t n, int sw)
{
	int	i,st;
	for(i=0;i<n;i+=4){
		st=pa_cpy_4(arm,dest,src,sw);
		dest+=i;
		src+=i;
	}
	return(st);
}
/******************************************************************

******************************************************************/
DllExport long  pa_cpy_flt(long arm,void *dest,void *src, int sw)
{
	int	st;
	st=pa_cpy_4(arm,dest,src,sw);
	return(st);
}
/******************************************************************

******************************************************************/
DllExport long  pa_cpy_lng(long arm,void *dest,void *src, int sw)
{
	int	st;
	st=pa_cpy_4(arm,dest,src,sw);
	return(st);
}
/******************************************************************

******************************************************************/
DllExport long  pa_cpy_uby(long arm,void *dest,void *src, int sw)
{
	DataType	*s=(DataType *)src;
	PA_ARG		arg;

	arg.arm=arm/2;
	arg.size=1;
	arg.data[0]=*s;
	ioctl(_dev_,PA_INTR_PCI,&arg);
	return(0);
}
/******************************************************************

******************************************************************/
DllExport long  pa_ret_lng(long arm,void *src)
{
	int	st;
	long	tmp;

	st=pa_cpy_4(arm,(void*)&tmp,src,1);
	return(tmp);
}
/***************************************************************

***************************************************************/
static long chk_stat(ARM armno, short* arm)
{
	switch(armno){
	case ARM0:		*arm=0;		break;
	case ARM1:		*arm=1;		break;
	case ARM2:		*arm=2;		break;
	case ARM3:		*arm=3;		break;
	case ARM4:		*arm=4;		break;
	case ARM5:		*arm=5;		break;
	case ARM6:		*arm=6;		break;
	case ARM7:		*arm=7;		break;
	case ARM8:		*arm=8;		break;
	case ARM9:		*arm=9;		break;
	case ARM10:		*arm=10;	break;
	case ARM11:		*arm=11;	break;
	case ARM12:		*arm=12;	break;
	case ARM13:		*arm=13;	break;
	case ARM14:		*arm=14;	break;
	case ARM15:		*arm=15;	break;
	default:			return ERR_ARM;
	}
	return ERR_OK;
}
/***************************************************************

***************************************************************/
DllExport long  pa_map_ctl(ARM armno)
{
	long	err;
	short	arm;
	if( ERR_OK==(err=chk_stat(armno,&arm)) ){
		_486req = (int *)CtlPCI( arm );
		_d14[arm]=_d14_[arm];
	}
	return err;
}
/***************************************************************

*******************************************************************/
DllExport long  pa_req_ctl(ARM armno, long num)
{
	long			err;
	static	long		_d9,d14;
	short 			arm;
	static	long		ldmy;
    	static	unsigned char	ubdmy;
	long			tmp; /* ocr=0; */
	long			intr_no;

	if( ERR_OK!=(err=chk_stat(armno,&arm)) )return err;

	if(armno%2)	intr_no=2;
	else		intr_no=1;

	pa_cpy_lng((long)armno,&_d9,&(_comuni->hu.flg.flag[3]),1);
	d14=_d14_[arm];							
	pa_cpy_lng((long)armno,&(_d14_[arm]),&(_comuni->hu.err.dmy[14]),1);
	pa_cpy_lng((long)armno,&(_d14[arm]),&(_comuni->hu.err.dmy[14]),1);
	for(;;){
		pa_cpy_lng((long)armno,&ldmy,&(_comuni->hu.flg.flag[4]),1);
		ldmy +=(long)(1);
		pa_cpy_lng((long)armno,&(_comuni->hu.flg.flag[4]),&ldmy,2);
//		ubdmy = (unsigned char)((int)armno+1+8*ocr);
		ubdmy = (unsigned char)(intr_no);
	 	pa_cpy_uby((long)armno,_486req,&ubdmy,2 );
		if( !num-- ){
			_d14_[arm]=_d14[arm]=d14;
			return ERR_INT;
		}
		for(tmp=0;tmp<1000;tmp++){
			pa_cpy_lng(	(long)armno,&ldmy,&(_comuni->hu.flg.flag[3]),1);
			if( _d9 != ldmy )break;
		}
		if( _d9 != ldmy )	break;
		
		pa_cpy_lng((long)armno,	&ldmy,&(_comuni->hu.flg.flag[5]),1);
		ldmy +=(long)1;
		pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[5]),&ldmy,2);
	}
	ldmy =(long)0;
	pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[0]),&ldmy,2);
	pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[1]),&ldmy,2);
	return ERR_OK;
}
/***************************************************************

*******************************************************************/
DllExport long  pa_req_sub(ARM armno, long num)
{
	long 			err;
	long		 	_d9,d3;
	short 			arm;
	long			ldmy;
    	unsigned char		ubdmy;
	long			tmp;
	long			intr_no;

	if( ERR_OK!=(err=chk_stat(armno,&arm)) )return err;

	if(arm%2)	intr_no=2;
	else		intr_no=1;

	pa_cpy_lng((long)armno,	&(_d9),&(_comuni->hu.flg.flag[3]),1);
	d3=_d3_[arm];
	pa_cpy_lng((long)armno,	&(_d3_[arm]),&(_comuni->hu.err.dmy[3]),1);
	pa_cpy_lng((long)armno,	&(_d3[arm]),&(_comuni->hu.err.dmy[3]),1);
	
	for(;;){
		pa_cpy_lng((long)armno,	&ldmy,&(_comuni->hu.flg.flag[4]),1);
		ldmy +=(long)1;
		pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[4]),&ldmy,2);
//		ubdmy = (unsigned char)((int)armno+1);
		ubdmy = (unsigned char)(intr_no);
	    	pa_cpy_uby((long)armno,	_486req,&ubdmy,2 );
		if( !num-- ){
			_d3_[arm]=_d3[arm]=d3;
			return ERR_INT;
		}
		for(tmp=0;tmp<100;tmp++){
			pa_cpy_lng((long)armno,	&ldmy,&(_comuni->hu.flg.flag[3]),1);
			if( _d9 != ldmy )break;
		}
		if( _d9 != ldmy )	break;
		pa_cpy_lng((long)armno,	&ldmy,&(_comuni->hu.flg.flag[5]),1);
		ldmy +=(long)1;
		pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[5]),&ldmy,2);
	}

	ldmy = (long)	0;
	pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[0]),&ldmy,2);
	pa_cpy_lng((long)armno,	&(_comuni->hu.flg.flag[1]),&ldmy,2);
	return ERR_OK;
}
/*********************************************************************

*********************************************************************/
DllExport short  pa_fsh_chk(ARM armno)
{
	static	long	ldmy;

	if( ERR_OK!=pa_map_ctl(armno) )return ERR_OK;
	pa_cpy_lng((long)armno,	&ldmy,&(_comuni->hu.err.dmy[14]),1);

	return _d14[armno]!=ldmy?0:1;
}
/*********************************************************************

**********************************************************************/
DllExport short  pa_fsh_sub(ARM armno)
{
	long	ldmy;

	if( ERR_OK!=pa_map_ctl(armno) )return ERR_OK;
	pa_cpy_lng(	(long)armno,&ldmy,&(_comuni->hu.err.dmy[3]),1);

	return _d3[armno]!=ldmy?0:1;
}
/***************************************************************

***************************************************************/
DllExport long  pa_ini_sys(void)
{
	return ERR_OK;
}
/***************************************************************

***************************************************************/
DllExport long  pa_ter_sys(void)
{
	return ERR_OK;
}
/***************************************************************

***************************************************************/
DllExport long  pa_opn_arm(ARM armno)
{
	MakeMutex((long)armno);
	return WinRTinit((long)armno);
}
/***************************************************************

***************************************************************/
DllExport long  pa_cls_arm(ARM armno)
{
	long	err=ERR_OK;
	DestroyMutex((long)armno);
	WinRTabort((long)armno);
	return err;
}
