//ANSI C
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//X Toolkit
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

//Athena Widget
#include <X11/Xaw3d/Toggle.h>
#include <X11/Xaw3d/Text.h>

//PA
#include <pa.h>
#include <paerr.h>
#include "Resource.h"
#include "arm.h"

static Boolean	RepeatMode=False;
static long	PA_count;
static void	SetRepeat(void);
static void	ResetRepeat(void);

//λ
void QuitProc(Widget w,caddr_t clntd,caddr_t calld)
{
	ResetRepeat();
	if(Dialog(
		"ץνλ",
		"ץλޤ"
		)==DIALOG_YES){
		exit(0);
	}
}

//ܻư
void HomProc(Widget w,caddr_t clntd,caddr_t calld)
{
	ResetRepeat();
	if(Dialog(
		"ܻ˰ư",
		"ܻ˰ưޤ"
		)==DIALOG_YES){
		pa_exe_hom(Res.armNo,WM_NOWAIT);
	}
}
//ư
void EscProc(Widget w,caddr_t clntd,caddr_t calld)
{
	ResetRepeat();
	if(Dialog(
		"˰ư",
		"˰ưޤ"
		)==DIALOG_YES){
		pa_exe_esc(Res.armNo,WM_NOWAIT);
	}
}
//ư
void SafProc(Widget w,caddr_t clntd,caddr_t calld)
{
	ResetRepeat();
	if(Dialog(
		"˰ư",
		"˰ưޤ"
		)==DIALOG_YES){
		pa_exe_saf(Res.armNo,WM_NOWAIT);
	}
}
//֥졼
void BrkProc(Widget w,caddr_t clntd,caddr_t calld)
{
	ResetRepeat();
	pa_stp_arm(Res.armNo,WM_NOWAIT);
}
//顼ꥢ
void RstProc(Widget w,caddr_t clntd,caddr_t calld)
{
	pa_rst_ctl(Res.armNo);
}

//
void AllAxsProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Arg	args[10];
	int	i;

	//ȥܥ򤹤٤ON
	i=0;
	XtSetArg(args[i],XtNstate,True);	i++;
	XtSetValues(AppObj.s1_axs,args,i);
	XtSetValues(AppObj.s2_axs,args,i);
	XtSetValues(AppObj.s3_axs,args,i);
	XtSetValues(AppObj.e1_axs,args,i);
	XtSetValues(AppObj.e2_axs,args,i);
	XtSetValues(AppObj.w1_axs,args,i);
	XtSetValues(AppObj.w2_axs,args,i);
}
//
void NonAxsProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Arg	args[10];
	int	i;

	//ȥܥ򤹤٤OFF
	i=0;
	XtSetArg(args[i],XtNstate,False);	i++;
	XtSetValues(AppObj.s1_axs,args,i);
	XtSetValues(AppObj.s2_axs,args,i);
	XtSetValues(AppObj.s3_axs,args,i);
	XtSetValues(AppObj.e1_axs,args,i);
	XtSetValues(AppObj.e2_axs,args,i);
	XtSetValues(AppObj.w1_axs,args,i);
	XtSetValues(AppObj.w2_axs,args,i);
}

//򤵤Ƥ뼴
static AXIS GetSelectAxis()
{
	Arg	args[10];
	int	i;
	Boolean	state;
	AXIS	axis=0;
	i=0;
	XtSetArg(args[i],XtNstate,&state);	i++;
	XtGetValues(AppObj.s1_axs,args,i);
	if(state)	axis|=S1;
	XtGetValues(AppObj.s2_axs,args,i);
	if(state)	axis|=S2;
	XtGetValues(AppObj.s3_axs,args,i);
	if(state)	axis|=S3;
	XtGetValues(AppObj.e1_axs,args,i);
	if(state)	axis|=E1;
	XtGetValues(AppObj.e2_axs,args,i);
	if(state)	axis|=E2;
	XtGetValues(AppObj.w1_axs,args,i);
	if(state)	axis|=W1;
	XtGetValues(AppObj.w2_axs,args,i);
	if(state)	axis|=W2;

	return axis;
}

//ƼON
void SvoProc(Widget w,caddr_t clntd,caddr_t calld)
{
	AXIS	axis;
	ANGLE	angle;

	if(Dialog(
		"ܥå",
		"ܥåޤ"
		)==DIALOG_YES){
		axis=GetSelectAxis();
		if(axis==0)
			printf("Warning : No axis selected!\n");
	
		pa_get_agl(Res.armNo,&angle);	//߳
		pa_exe_axs(Res.armNo,axis,&angle,WM_NOWAIT);
	}
}

//TURBOɤ
static Boolean IsTurboMode()
{
	Arg	args[10];
	int	i;
	Boolean	state;
	i=0;
	XtSetArg(args[i],XtNstate,&state);	i++;
	XtGetValues(AppObj.turbo,args,i);
	return state;
}

//UP/DOWN
void UpProc(Widget w,caddr_t clntd,caddr_t calld)
{
	AXIS	axis;
	ANGLE	angle;
	float	dest;

	ResetRepeat();

	if((axis=GetSelectAxis())==0){
		printf("Warning : No axis selected!\n");
		return;
	}

	if(IsTurboMode())
		dest=(float)Res.armDestTurbo;
	else
		dest=(float)Res.armDest;

	pa_get_agl(Res.armNo,&angle);	//߳

	angle.s1+=dest;
	angle.s2+=dest;
	angle.s3+=dest;
	angle.e1+=dest;
	angle.e2+=dest;
	angle.w1+=dest;
	angle.w2+=dest;

	pa_exe_axs(Res.armNo,axis,&angle,WM_NOWAIT);
}
void DownProc(Widget w,caddr_t clntd,caddr_t calld)
{
	AXIS	axis;
	ANGLE	angle;
	float	dest;

	ResetRepeat();

	if((axis=GetSelectAxis())==0){
		printf("Warning : No axis selected!\n");
		return;
	}

	if(IsTurboMode())
		dest=(float)Res.armDestTurbo;
	else
		dest=(float)Res.armDest;

	pa_get_agl(Res.armNo,&angle);	//߳

	angle.s1-=dest;
	angle.s2-=dest;
	angle.s3-=dest;
	angle.e1-=dest;
	angle.e2-=dest;
	angle.w1-=dest;
	angle.w2-=dest;

	pa_exe_axs(Res.armNo,axis,&angle,WM_NOWAIT);
}

//Ƽͤɽ
static void SetAxis(Widget w,float value)
{
	char	buffer[80];
	Arg	args[10];
	int	i=0;
	sprintf(buffer,Res.valueFormat,value*180.0/M_PI);
	XtSetArg(args[i],XtNlabel,buffer);	i++;
	XtSetValues(w,args,i);
}

//֤߰ɽ
static void SetXyzYpr(Widget w,float value)
{
	char	buffer[80];
	Arg	args[10];
	int	i=0;
	sprintf(buffer,Res.valueFormat,value);
	XtSetArg(args[i],XtNlabel,buffer);	i++;
	XtSetValues(w,args,i);
}

//֤ɽ
static void SetStatus(String str)
{
	Arg	args[10];
	int	i;
	Dimension	width;

	//٥륦åȤΥ
	i=0;
	XtSetArg(args[i],XtNwidth,&width);	i++;
	XtGetValues(AppObj.arm_sts,args,i);

	i=0;
	XtSetArg(args[i],XtNlabel,str);	i++;
	XtSetArg(args[i],XtNwidth,width);	i++;
	XtSetValues(AppObj.arm_sts,args,i);
}
//顼ֹ
static void SetError(String str)
{
	Arg	args[10];
	int	i;
	Dimension	width;

	//٥륦åȤΥ
	i=0;
	XtSetArg(args[i],XtNwidth,&width);	i++;
	XtGetValues(AppObj.err_num,args,i);

	i=0;
	XtSetArg(args[i],XtNlabel,str);	i++;
	XtSetArg(args[i],XtNwidth,width);	i++;
	XtSetValues(AppObj.err_num,args,i);
}

//ȥݥɽ
static void SetCur(long cur)
{
	char	buffer[80];
	Arg	args[10];
	int	i;
	Dimension	width;

	sprintf(buffer,"%d",cur);

	//٥륦åȤΥ
	i=0;
	XtSetArg(args[i],XtNwidth,&width);	i++;
	XtGetValues(AppObj.cur_pnt,args,i);

	i=0;
	XtSetArg(args[i],XtNlabel,buffer);	i++;
	XtSetArg(args[i],XtNwidth,width);	i++;
	XtSetValues(AppObj.cur_pnt,args,i);
}
//ɽ
static void SetNum(long num)
{
	char	buffer[80];
	Arg	args[10];
	int	i;
	Dimension	width;

	sprintf(buffer,"%d",num);

	//٥륦åȤΥ
	i=0;
	XtSetArg(args[i],XtNwidth,&width);	i++;
	XtGetValues(AppObj.num_pnt,args,i);

	i=0;
	XtSetArg(args[i],XtNlabel,buffer);	i++;
	XtSetArg(args[i],XtNwidth,width);	i++;
	XtSetValues(AppObj.num_pnt,args,i);
}

//ȥݥȰư(Ƽ)
void AxsPntProc(Widget w,caddr_t clntd,caddr_t calld)
{
	if(PntNum<1)	return;
	if(Dialog(
		"ȥݥȤ˰ư",
		"ȥݥȤ˳Ƽưޤ"
		)==DIALOG_YES){
		pa_axs_pnt(Res.armNo,WM_NOWAIT);
	}
}
//ȥݥȰư(ľ)
void MovPntProc(Widget w,caddr_t clntd,caddr_t calld)
{
	if(PntNum<1)	return;
	if(Dialog(
		"ȥݥȤ˰ư",
		"ȥݥȤľưޤ"
		)==DIALOG_YES){
		pa_mov_pnt(Res.armNo,WM_NOWAIT);
	}
}
//Ϣ³ž
static void SetRepeat()
{
	RepeatMode=True;
}
static void ResetRepeat()
{
	if(RepeatMode==True){
		printf("RepeatMode STOPPED\n");
		RepeatMode=False;
		pa_sus_arm(Res.armNo,WM_NOWAIT);
	}
}

void PlyPntProc(Widget w,caddr_t clntd,caddr_t calld)
{
	if(PntNum<1)	return;
	if(Dialog(
		"Ϣ³ž",
		"Ϣ³ž򳫻Ϥޤ Ǥ"
		)==DIALOG_YES){
		pa_get_cnt(Res.armNo,&PA_count);
		if(CurPnt<2){
		//	pa_ena_jmp(Res.armNo,JMP_OFF);
			pa_ply_pnt(Res.armNo,PB_FORE,1,WM_NOWAIT);
		}else{
		//	pa_ena_jmp(Res.armNo,JMP_OFF);
			pa_ply_pnt(Res.armNo,PB_BACK,1,WM_NOWAIT);
		}
		SetRepeat();
	}
}
//Ϣ³ž
void RepStpProc(Widget w,caddr_t clntd,caddr_t calld)
{
	ResetRepeat();
}

//ǡɤ߹
void ReadFileProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Arg	args[10];
	int	i;
	String	filename;

	i=0;
	XtSetArg(args[i],XtNstring,&filename);	i++;
	XtGetValues(AppObj.fil_txt,args,i);

	pa_lod_pnt(Res.armNo,1,(char*)filename);
}
//ǡ񤭹
void WriteFileProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Arg	args[10];
	int	i;
	String	filename;

	if(PntNum<1)	return;
	i=0;
	XtSetArg(args[i],XtNstring,&filename);	i++;
	XtGetValues(AppObj.fil_txt,args,i);
printf("save:%s\n",filename);
	pa_sav_pnt(Res.armNo,(char*)filename);
}
//ե̾ƥȤʸ򥻥å()
void SetFileName(String file)
{
	Arg	args[10];
	int	i=0;
	String	filename;
	XawTextBlock	blk;

	blk.firstPos=0;
	blk.length=strlen(file);
	blk.ptr=file;
	blk.format=0;

	//ѹθߤΥե̾
	XtSetArg(args[i],XtNstring,&filename);	i++;
	XtGetValues(AppObj.fil_txt,args,i);

	//ƥִ
	XawTextReplace(AppObj.fil_txt,0,strlen(filename),&blk);
}

//ե뻲
void RefFileProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Filer();
}

//åץǡ
static void UpdateArm(void)
{
	pa_get_sts(Res.armNo,&ArmStatus);
	pa_get_mod(Res.armNo,&ArmMode);
	pa_get_cur(Res.armNo,&CurPnt);
	pa_get_num(Res.armNo,&PntNum);
}
static void UpdateScreen(void)
{
	char	message[255];

	//ͤι
	if(OldArmStatus.angle.s1!=ArmStatus.angle.s1)
		SetAxis(AppObj.s1_val,ArmStatus.angle.s1);
	if(OldArmStatus.angle.s2!=ArmStatus.angle.s2)
		SetAxis(AppObj.s2_val,ArmStatus.angle.s2);
	if(OldArmStatus.angle.s3!=ArmStatus.angle.s3)
		SetAxis(AppObj.s3_val,ArmStatus.angle.s3);
	if(OldArmStatus.angle.e1!=ArmStatus.angle.e1)
		SetAxis(AppObj.e1_val,ArmStatus.angle.e1);
	if(OldArmStatus.angle.e2!=ArmStatus.angle.e2)
		SetAxis(AppObj.e2_val,ArmStatus.angle.e2);
	if(OldArmStatus.angle.w1!=ArmStatus.angle.w1)
		SetAxis(AppObj.w1_val,ArmStatus.angle.w1);
	if(OldArmStatus.angle.w2!=ArmStatus.angle.w2)
		SetAxis(AppObj.w2_val,ArmStatus.angle.w2);

	//֤߰ι
	if(OldArmStatus.noap[0][3]!=ArmStatus.noap[0][3])
		SetXyzYpr(AppObj.rx_val,ArmStatus.noap[0][3]);
	if(OldArmStatus.noap[1][3]!=ArmStatus.noap[1][3])
		SetXyzYpr(AppObj.ry_val,ArmStatus.noap[1][3]);
	if(OldArmStatus.noap[2][3]!=ArmStatus.noap[2][3])
		SetXyzYpr(AppObj.rz_val,ArmStatus.noap[2][3]);

	//߻ι
	if(OldArmStatus.ypr[0]!=ArmStatus.ypr[0])
		SetXyzYpr(AppObj.yaw_val,ArmStatus.ypr[0]);
	if(OldArmStatus.ypr[1]!=ArmStatus.ypr[1])
		SetXyzYpr(AppObj.pitch_val,ArmStatus.ypr[1]);
	if(OldArmStatus.ypr[2]!=ArmStatus.ypr[2])
		SetXyzYpr(AppObj.roll_val,ArmStatus.ypr[2]);

	//֤ɽ
	if(OldArmMode!=ArmMode){
	/*	pa_get_mes(ArmMode,message);	*/
		switch(ArmMode){
		case  1:SetStatus("--------------------------(1)");	break;
		case  2:SetStatus("--------------------------(2)");	break;
		case  3:SetStatus("֥졼߾          (3)");	break;
		case  4:SetStatus("--------------------------(4)");	break;
		case  5:SetStatus("--------------------------(5)");	break;
		case  6:SetStatus("--------------------------(6)");	break;
		case  7:SetStatus("--------------------------(7)");	break;
		case  8:SetStatus("Ƽ          (8)");	break;
		case  9:SetStatus("Ƽ®          (9)");	break;
		case 10:SetStatus("ܥå         (10)");	break;
		case 11:SetStatus("ʰ׼         (11)");	break;
		case 12:SetStatus("             (12)");	break;
		case 13:SetStatus("RMRC             (13)");	break;
		case 14:SetStatus("RMRCĹ       (14)");	break;
		case 15:SetStatus("Ƽ極ܥå (15)");	break;
		case 16:SetStatus("CPǡץ쥤Хå (16)");	break;
		case 17:SetStatus("Ƽ       (17)");	break;
		case 18:SetStatus("ץ쥤Хå־   (18)");	break;
		case 19:SetStatus("ץ쥤Хåľ־ (19)");	break;
		case 20:SetStatus("ץ쥤Хå߸־ (20)");	break;
		case 21:SetStatus("RMRC極ܥå (21)");	break;
		case 22:SetStatus("ץ쥤ХåԾ   (22)");	break;
		case 23:SetStatus("Ƽ極ܥå (23)");	break;
		case 24:SetStatus("RMRC極ܥå (24)");	break;
		case 25:SetStatus("ץ쥤ХåԾ   (25)");	break;
		case 26:SetStatus("ץ쥤ХåԾ   (26)");	break;
		case 27:SetStatus("Ĺ           (27)");	break;
		case 28:SetStatus("RMRCꥢ       (28)");	break;
		case 29:SetStatus("ץ쥤ХåƼ־ (29)");	break;
		case 30:SetStatus("ɸѴ     (30)");	break;
		case 31:SetStatus("ĹS    (31)");	break;
		case 32:SetStatus("Ƽꥢ       (32)");	break;
		default:SetStatus("ʾ               (**)");	break;
		}
	}
	//顼ֹɽ
	if(OldArmStatus.error!=ArmStatus.error){
		pa_err_mes(ArmStatus.error,message);
		SetError(message);
	}
	//ȥݥ
	if(OldCurPnt!=CurPnt){
		SetCur(CurPnt);
	}
	//
	if(OldPntNum!=PntNum){
		SetNum(PntNum);
	}
}

//ޥ롼
void TimerProc(Widget w,XtIntervalId *id)
{
	static Boolean flag=False;
	Arg	args[1];
	int	i;
	i=0;
	if(flag==False){
		XtSetArg(args[i],XtNforeground,Res.intervalFg1);	i++;
		flag=True;
	}else{
		XtSetArg(args[i],XtNforeground,Res.intervalFg2);	i++;
		flag=False;
	}
	XtSetValues(w,args,i);

	UpdateArm();				//󹹿

	UpdateScreen();				//ɽ

	if(RepeatMode==True){			//Ϣ³ž?
		if(ArmStatus.error==ERR_OK){	//顼̵
			long	cnt;
			pa_get_cnt(Res.armNo,&cnt);
			if(PA_count!=cnt){	//ưλ
				pa_get_cnt(Res.armNo,&PA_count);
				if(CurPnt<2){
					pa_ena_jmp(Res.armNo,JMP_OFF);
					pa_ply_pnt(Res.armNo,PB_FORE,1,WM_NOWAIT);
				}else{
					pa_ena_jmp(Res.armNo,JMP_OFF);
					pa_ply_pnt(Res.armNo,PB_BACK,1,WM_NOWAIT);
				}
			}
		}else{
			ResetRepeat();
		}
	}else{
		ResetRepeat();
	}

	//ͤι
	memcpy(&OldArmStatus,&ArmStatus,sizeof(ARMSTATUS));
	OldArmMode=ArmMode;
	OldCurPnt=CurPnt;
	OldPntNum=PntNum;

	XtAppAddTimeOut(
		AppObj.AppContext,
		Res.interval,
		(XtTimerCallbackProc)TimerProc,w);
}

//̿Ƴ
void RestartProc(Widget w,caddr_t clntd,caddr_t calld)
{
	long	com;

	ResetRepeat();

	pa_get_com(Res.armNo,&com);
	switch(com){
	case	1:
		pa_sta_arm(Res.armNo);
		break;
	case	2:
		pa_sta_sim(Res.armNo);
		break;
	}
}

//к
void MovXyzProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Arg	args[10];
	String	values;
	char	buffer[80];
	XawTextBlock	blk;
	float	dx,dy,dz;

	ResetRepeat();

	blk.firstPos=0;
	blk.ptr=buffer;
	blk.format=0;

	//ͤեޥå(ʸ͢Ѵ)
	XtSetArg(args[0],XtNstring,&values);
	XtGetValues(AppObj.dX,args,1);
	dx=atof(values);
	sprintf(buffer,Res.valueDFormat,dx);
	blk.length=strlen(buffer);
	XawTextReplace(AppObj.dX,0,strlen(values),&blk);
	//åȤǽ֤
	XawTextSetInsertionPoint(AppObj.dX,strlen(values));

	XtGetValues(AppObj.dY,args,1);
	dy=atof(values);
	sprintf(buffer,Res.valueDFormat,dy);
	blk.length=strlen(buffer);
	XawTextReplace(AppObj.dY,0,strlen(values),&blk);
	XawTextSetInsertionPoint(AppObj.dY,strlen(values));

	XtGetValues(AppObj.dZ,args,1);
	dz=atof(values);
	sprintf(buffer,Res.valueDFormat,dz);
	blk.length=strlen(buffer);
	XawTextReplace(AppObj.dZ,0,strlen(values),&blk);
	XawTextSetInsertionPoint(AppObj.dZ,strlen(values));

	if(Dialog(
		"кư",
		"ͤ˰ưޤ"
		)==DIALOG_YES){
		pa_mov_XYZ(Res.armNo,dx,dy,dz,WM_NOWAIT);
	}
}
//к
void MovYprProc(Widget w,caddr_t clntd,caddr_t calld)
{
	Arg	args[10];
	String	values;
	char	buffer[80];
	XawTextBlock	blk;
	float	dyaw,dpitch,droll;

	ResetRepeat();

	blk.firstPos=0;
	blk.ptr=buffer;
	blk.format=0;

	//ͤեޥå(ʸ͢Ѵ)
	XtSetArg(args[0],XtNstring,&values);
	XtGetValues(AppObj.dYaw,args,1);
	dyaw=atof(values);
	sprintf(buffer,Res.valueDFormat,dyaw);
	blk.length=strlen(buffer);
	XawTextReplace(AppObj.dYaw,0,strlen(values),&blk);
	XawTextSetInsertionPoint(AppObj.dYaw,strlen(values));

	XtGetValues(AppObj.dPitch,args,1);
	dpitch=atof(values);
	sprintf(buffer,Res.valueDFormat,dpitch);
	blk.length=strlen(buffer);
	XawTextReplace(AppObj.dPitch,0,strlen(values),&blk);
	XawTextSetInsertionPoint(AppObj.dPitch,strlen(values));

	XtGetValues(AppObj.dRoll,args,1);
	droll=atof(values);
	sprintf(buffer,Res.valueDFormat,droll);
	blk.length=strlen(buffer);
	XawTextReplace(AppObj.dRoll,0,strlen(values),&blk);
	XawTextSetInsertionPoint(AppObj.dRoll,strlen(values));

	if(Dialog(
		"кư",
		"ͤ˰ưޤ"
		)==DIALOG_YES){
	/*
		pa_mov_YPR(Res.armNo,dyaw,dpitch,droll,WM_NOWAIT);
	*/
		pa_mov_YPR(Res.armNo,(dyaw*3.141592)/180.0,
				     (dpitch*3.141592)/180.0,
				     (droll*3.141592)/180.0,WM_NOWAIT);
	}
}

//ȥݥѹ
void ChgPntProc(Widget w,caddr_t clntd,caddr_t calld)
{
//	Widget current=XawToggleGetCurrent(AppObj.cur_top);
	Boolean	state;
	Arg	args[10];
	XtSetArg(args[0],XtNstate,&state);
	XtGetValues(AppObj.cur_top,args,1);
	if(state==True)
		pa_chg_pnt(Res.armNo,PM_TOP,0);
	XtGetValues(AppObj.cur_next,args,1);
	if(state==True)
		pa_chg_pnt(Res.armNo,PM_NEXT,0);
	XtGetValues(AppObj.cur_bottom,args,1);
	if(state==True)
		pa_chg_pnt(Res.armNo,PM_BTM,0);
}
//PTPɤ߹(ݥɲ)
void AddPntProc1(Widget w,caddr_t clntd,caddr_t calld)
{
	if(Dialog(
		"PTP(Ƽ)ɹ",
		"ɲäޤ Ǥ"
		)==DIALOG_YES){
		pa_add_pnt(Res.armNo,PT_AXS);
	}
}
void AddPntProc2(Widget w,caddr_t clntd,caddr_t calld)
{
	if(Dialog(
		"PTP(ľ)ɹ",
		"ɲäޤ Ǥ"
		)==DIALOG_YES){
		pa_add_pnt(Res.armNo,PT_PTP);
	}
}
//ݥȥǡ
void DelPntProc1(Widget w,caddr_t clntd,caddr_t calld)
{
	if(PntNum<1)	return;
	if(Dialog(
		"ȥǡ",
		"ޤ Ǥ"
		)==DIALOG_YES){
		pa_del_pnt(Res.armNo,PD_CUR);
	}
}
void DelPntProc2(Widget w,caddr_t clntd,caddr_t calld)
{
	if(PntNum<1)	return;
	if(Dialog(
		"ǡ",
		"ޤ Ǥ"
		)==DIALOG_YES){
		pa_del_pnt(Res.armNo,PD_ALL);
	}
}

