/*
 *  paLibError.c
 *
 *  Daniel SIDOBRE
 *
 * Copyright (c) 2004 LAAS/CNRS 
 *
 *   Fonction crite  partir du fichier paerr.h et du pa10 series programming manual
 */
#include "paerr.h"


char* pa10ErrorGetString(long numError)
{
  switch(numError) {
  case ERR_OK: return "ERR_OK: No Error";
    /* (1) operation control section (PA library) detection error */
  case ERR_FILE: return "ERR_FILE: Designated file does not exist";
  case ERR_READ: return "ERR_READ: File loading failure";
  case ERR_WRITE: return "ERR_WRITE: File saving failure";
  case ERR_INT: return "ERR_INT: Unsuccessful interruption into 486";
  case ERR_OPEN: return "ERR_OPEN: pa_opn_arm() not executed";
  case ERR_MALLOC: return "ERR_MALLOC: Failed to allocate memory space";
  case ERR_PRM: return "ERR_PRM: Parameter alteration not allowed when in control";
  case ERR_PNT: return "ERR_PNT: A specified degree of teaching data is out of range";
    /* Parameter error */
  case ERR_ARM: return "ERR_ARM: Designated arm not existing";
  case ERR_AXIS: return "ERR_AXIS: Designated axis not existing";
  case ERR_DRV: return "ERR_DRV: Designated driver not existing";
  case ERR_PB: return "ERR_PB: Incorrect playback motion mode";
  case ERR_PD: return "ERR_PD: Incorrect teach point deletionm mode";
  case ERR_PA: return "ERR_PA: Incorrect teach point attribution mode";
  case ERR_PTN: return "ERR_PTN: Incorrect teach point velocity pattern attribution mode";
  case ERR_PT: return "ERR_PT: Incorrect teach point data type";
  case ERR_PM: return "ERR_PM: Incorrect teach point operation type";
  case ERR_VT: return "ERR_VT: Incorrect default velocity alteration type";
  case ERR_VM: return "ERR_VM: Incorrect velocity control mode";
  case ERR_JM: return "ERR_JM: Incorrect redundant axis control mode";
  case ERR_JT: return "ERR_JT: Incorrect redundant axis operation mode";
  case ERR_MM: return "ERR_MM: Incorrect target tip matrix control mode";
  case ERR_DM: return "ERR_DM: Incorrect direct control mode";
  case ERR_DP: return "ERR_DP: Incorrect digital input/output port designation";
  case ERR_DC: return "ERR_DC: Incorrect digital input/output channel designation";
  case ERR_MES: return "ERR_MES: Error code not defined";
  case ERR_BOARD: return "ERR_BOARD: Error code not defined";
  case ERR_DIO: return "ERR_DIO: Incorrect digital input/output DIorDO designation";
  case ERR_PRJ: return "ERR_PRJ: project not loaded";
    /* WinRT error */
  case ERR_UNMAPMEMORY: return "ERR_UNMAPMEMORY: Error occured in WinRTUnMapMemory";
  case ERR_UNMAPMEMORY2: return "ERR_UNMAPMEMORY2: Error occured in WinRTUnMapMemory2";
  case ERR_OPENDEVICE: return "ERR_OPENDEVICE: Error occured in WinRTOpenNamedDevice";
  case ERR_CONFIG: return "ERR_CONFIG: Error occured in WinRTGetFullConfiguration";
  case ERR_MAPMEMORY: return "ERR_MAPMEMORY: Error occured in WinRTMapMemory";
  case ERR_MAPMEMORY2: return "ERR_MAPMEMORY2: Error occured in WinRTMapMemory2";
    /* (2) Motion control section detection error */
  case ERR_CANT_CPU: return "ERR_CANT_CPU: Access to motion controller not allowed";
  case ERR_NON_EVNT: return "ERR_NON_EVNT: Format does not match with command";
  case ERR_CANT_EVNT: return "ERR_CANT_EVNT: Command not compatible with current mode";
  case ERR_INVALD_EVNT: return "ERR_INVALD_EVNT: Invalid command";
    /*=== Ver.PCI ====*/
  case ERR_NON_ARM: return "ERR_NON_ARM: Designated arm number not existing";
  case ERR_NON_ROB: return "ERR_NON_ROB: Download new ROB file";
  case ERR_NON_TOL: return "ERR_NON_TOL: Download new TOL file";
    /*===============*/
  case ERR_S1_VEL: return "ERR_S1_VEL: S1 axis velocity exceeded";
  case ERR_S2_VEL: return "ERR_S2_VEL: S2 axis velocity exceeded";
  case ERR_S3_VEL: return "ERR_S3_VEL: S3 axis velocity exceeded";
  case ERR_E1_VEL: return "ERR_E1_VEL: E1 axis velocity exceeded";
  case ERR_E2_VEL: return "ERR_E2_VEL: E2 axis velocity exceeded";
  case ERR_W1_VEL: return "ERR_W1_VEL: W1 axis velocity exceeded";
  case ERR_W2_VEL: return "ERR_W2_VEL: W2 axis velocity exceeded";
    /*===============*/
  case ERR_XYZ_VEL: return "ERR_XYZ_VEL: Tip linear velocity exceeded";
  case ERR_YPR_VEL: return "ERR_YPR_VEL: Tip rotational velocity exceeded";
    /*===============*/
  case ERR_S1_SAGL: return "ERR_S1_SAGL: S1 axis safety angle exceeded";
  case ERR_S2_SAGL: return "ERR_S2_SAGL: S2 axis safety angle exceeded";
  case ERR_S3_SAGL: return "ERR_S3_SAGL: S3 axis safety angle exceeded";
  case ERR_E1_SAGL: return "ERR_E1_SAGL: E1 axis safety angle exceeded";
  case ERR_E2_SAGL: return "ERR_E2_SAGL: E2 axis safety angle exceeded";
  case ERR_W1_SAGL: return "ERR_W1_SAGL: W1 axis safety angle exceeded";
  case ERR_W2_SAGL: return "ERR_W2_SAGL: W2 axis safety angle exceeded";
    /*=== Ver.1.3 ====*/
  case ERR_S1_TAGL: return "ERR_S1_TAGL: S1 axis target angle exceeded";
  case ERR_S2_TAGL: return "ERR_S2_TAGL: S2 axis target angle exceeded";
  case ERR_S3_TAGL: return "ERR_S3_TAGL: S3 axis target angle exceeded";
  case ERR_E1_TAGL: return "ERR_E1_TAGL: E1 axis target angle exceeded";
  case ERR_E2_TAGL: return "ERR_E2_TAGL: E2 axis target angle exceeded";
  case ERR_W1_TAGL: return "ERR_W1_TAGL: W1 axis target angle exceeded";
  case ERR_W2_TAGL: return "ERR_W2_TAGL: W2 axis target angle exceeded";
    /*===============*/
  case ERR_NOA_CLC: return "ERR_NOA_CLC: Unable to calculate NOA  Ver.PCI";
  case ERR_LNK_CTL: return "ERR_LNK_CTL: Unable to create teach point due to continuity restriction";
  case ERR_MEM_FULL: return "ERR_MEM_FULL: Failed to allocate memory space";
  case ERR_MIS_COMD: return "ERR_MIS_COMD: Prior procedure required before issuing this command";
  case ERR_PB_CIR: return "ERR_PB_CIR: Incorrect circle or arc designation";
  case ERR_PB_NEXT: return "ERR_PB_NEXT: Next pointer not existing";
  case ERR_PB_PRIV: return "ERR_PB_PRIV: Previous pointer not existing";
  case ERR_PB_END: return "ERR_PB_END: Playback data ended";
  case ERR_PB_NULL: return "ERR_PB_NULL: Playback data not existing";
  case ERR_PB_REFER: return "ERR_PB_REFER: Failed to find playback data";
  case ERR_PB_REPLACE: return "ERR_PB_REPLACE: Accepted as replace command";
  case ERR_PB_PANIC: return "ERR_PB_PANIC: pointer management accident";
    /*===============*/
  case ERR_NOT_ENUGH: return "ERR_NOT_ENUGH: Target value is out of control area. (Arm length is not enougth.)";
  case ERR_MIS_PARAM: return "ERR_MIS_PARAM: Designated parameter value exceeded the setting range";
  case ERR_NOA_DAT: return "ERR_NOA_DAT: Designated NOA not appropriate";
  case ERR_PNT_ATR: return "ERR_PNT_ATR: Not available";
  case ERR_PTP_DAT: return "ERR_PTP_DAT: Exceeding RMRC motion range";
  case ERR_CP_LOGGING: return "ERR_CP_LOGGING: not allowed to use while in CP data acquisition";
  case ERR_FIFO_MAX: return "ERR_FIFO_MAX: Exceeded the maximum interpolation number";
  case ERR_FIFO_ARC: return "ERR_FIFO_ARC: Unable to generate circle or arc";
    /*=== Ver.1.3 ====*/
  case COVERS1: return "ERR_FIFO_ARC: S1 axis velocity angle exceeded";
  case COVERS2: return "ERR_FIFO_ARC: S2 axis velocity angle exceeded";
  case COVERS3: return "ERR_FIFO_ARC: S3 axis velocity angle exceeded";
  case COVERE1: return "ERR_FIFO_ARC: E1 axis velocity angle exceeded";
  case COVERE2: return "ERR_FIFO_ARC: E2 axis velocity angle exceeded";
  case COVERW1: return "ERR_FIFO_ARC: W1 axis velocity angle exceeded";
  case COVERW2: return "ERR_FIFO_ARC: W2 axis velocity angle exceeded";
    /*=== Ver.PCI ====*/
  case ERR_MIS_VAL: return "ERR_MIS_VAL: setting value is too large or too small";
  case ERR_PNT_APP: return "ERR_PNT_APP: Approach cannot be performed with axis control";
    /*===============*/
  case ERR_PLY_FOR: return "ERR_PLY_FOR: Consecutive motion not allowed while in teach mode";
  case ERR_PLY_MOD: return "ERR_PLY_MOD: Switched to teach mode by outer operation";
  case ERR_USE_TCH: return "ERR_USE_TCH: Teach lock can be ON only in teach mode";
  case ERR_ACT_DAT: return "ERR_ACT_DAT: Designated Key teach data not existing";
  case ERR_CHG_KEY: return "ERR_CHG_KEY: Unable to perform Key reseach for teach data";
    /*===============*/
  case ERR_CUB_NUM: return "ERR_CUB_NUM: Interference area designation number error";
  case ERR_CUB_LEN: return "ERR_CUB_LEN: Side length designation cannot be performed with this cube information. This cube has another attribution";
  case ERR_CUB_MAX: return "ERR_CUB_MAX: Upper value teaching cannot be performed with this cube information. This cube has another attribution";
  case ERR_CUB_MIN: return "ERR_CUB_MIN: Lower value teaching cannot be performed with this cube information. This cube has another attribution";
  case ERR_CUB_CTR: return "ERR_CUB_CTR: Center value teaching cannot be performed with this cube information. This cube has another attribution";
  case ERR_CUB_PRM: return "ERR_CUB_PRM: Unknown cube parameter setting";
  case ERR_CUB_SET: return "ERR_CUB_SET: Setting connot be performed with this cube information. This cube has another attribution";
    /*===============*/
  case ERR_PLY_KEY: return "ERR_PLY_KEY: Wrong designation number when in Key acquisition";
    /*===============*/
  case ERR_NON_KEY: return "ERR_NON_KEY: There is no designated ID attribution in teach data designated by key";
  case ERR_NON_CID: return "ERR_NON_CID: Designated teach point has no JUMP data";
  case ERR_JMP_SET: return "ERR_JMP_SET: Teach data designated by Key does not have its number JUMP information";
  case ERR_NON_IDN: return "ERR_NON_IDN: teach point designated by ID attribution has no JUMP information";
  case ERR_JMP_NUM: return "ERR_JMP_NUM: Unable to find JUMP information designated by teach point attribution";
  case ERR_JMP_ATR: return "ERR_JMP_ATR: Wrong designated parameter when in JUMP data acquisition/setting";
  case ERR_KEY_ATR: return "ERR_KEY_ATR: Wrong designated parameter when in JUMP data acquisition/setting";
    /*===============*/
  case ERR_SOC_TST: return "ERR_SOC_TST: Socket generation failure";
  case ERR_BND_TST: return "ERR_BND_TST: Failed to bind socket and address";
  case ERR_LSN_TST: return "ERR_LSN_TST: Listening failure";
  case ERR_APT_TST: return "ERR_APT_TST: Accepting failure";
  case ERR_SOC_SND: return "ERR_SOC_SND: Socket generation failure";
  case ERR_SOC_BLK: return "ERR_SOC_BLK: Not available";
  case ERR_SOC_CLT: return "ERR_SOC_CLT: Too many clients connected";
    /*===============*/
  case ERR_PRM_DEV: return "ERR_PRM_DEV: Parameter motion velocity is exceeding velocity limit value. Parameter alteration is invalid";
    /* Operation continuity malfunction error --> (Brake-stop status) */
  case ERR_OVER900: return "ERR_OVER900: Arm length exceeded RMRC motion limit length while in motion";
    /*===============*/
  case ERR_S1_AGL: return "ERR_S1_AGL: S1 axis angle exceeded";
  case ERR_S2_AGL: return "ERR_S2_AGL: S2 axis angle exceeded";
  case ERR_S3_AGL: return "ERR_S3_AGL: S3 axis angle exceeded";
  case ERR_E1_AGL: return "ERR_E1_AGL: E1 axis angle exceeded";
  case ERR_E2_AGL: return "ERR_E2_AGL: E2 axis angle exceeded";
  case ERR_W1_AGL: return "ERR_W1_AGL: W1 axis angle exceeded";
  case ERR_W2_AGL: return "ERR_W2_AGL: W2 axis angle exceeded";
    /*=== Ver.1.3 ====*/
  case DOVERS1: return "ERR_W2_AGL: S1 axis direct control angle exceeded";
  case DOVERS2: return "ERR_W2_AGL: S2 axis direct control angle exceeded";
  case DOVERS3: return "ERR_W2_AGL: S3 axis direct control angle exceeded";
  case DOVERE1: return "ERR_W2_AGL: E1 axis direct control angle exceeded";
  case DOVERE2: return "ERR_W2_AGL: E2 axis direct control angle exceeded";
  case DOVERW1: return "ERR_W2_AGL: W1 axis direct control angle exceeded";
  case DOVERW2: return "ERR_W2_AGL: W2 axis direct control angle exceeded";
    /*===============*/
  case ERR_CANT_MOVE: return "ERR_CANT_MOVE: RMRC control is not allowed at the current position";
    /*===============*/
  case ERR_S1_REZ: return "ERR_S1_REZ: Anomalous S1 resolver deviation";
  case ERR_S2_REZ: return "ERR_S2_REZ: Anomalous S2 resolver deviation";
  case ERR_S3_REZ: return "ERR_S3_REZ: Anomalous S3 resolver deviation";
  case ERR_E1_REZ: return "ERR_E1_REZ: Anomalous E1 resolver deviation";
  case ERR_E2_REZ: return "ERR_E2_REZ: Anomalous E2 resolver deviation";
  case ERR_W1_REZ: return "ERR_W1_REZ: Anomalous W1 resolver deviation";
  case ERR_W2_REZ: return "ERR_W2_REZ: Anomalous W2 resolver deviation";
    /*
     * Anomalous resolver deviation means when the resolver value inputted at the
     *  previous time and the present time one exceed the allowable range.
     *  (incorrect loading, provokes missing data.)
     */
  case ERR_TIMEOUT: return "ERR_TIMEOUT: Automatically stopped on account of exceeding surveillance time";
  case ERR_SYNCOUT: return "ERR_SYNCOUT: Not reaching the target value";
    /*===============*/
  case ERR_SYNC_S1: return "ERR_SYNC_S1: Anomalous S1 axis synchronization in axis control";
  case ERR_SYNC_S2: return "ERR_SYNC_S2: Anomalous S2 axis synchronization in axis control";
  case ERR_SYNC_S3: return "ERR_SYNC_S3: Anomalous S3 axis synchronization in axis control";
  case ERR_SYNC_E1: return "ERR_SYNC_E1: Anomalous E1 axis synchronization in axis control";
  case ERR_SYNC_E2: return "ERR_SYNC_E2: Anomalous E2 axis synchronization in axis control";
  case ERR_SYNC_W1: return "ERR_SYNC_W1: Anomalous W1 axis synchronization in axis control";
  case ERR_SYNC_W2: return "ERR_SYNC_W2: Anomalous W2 axis synchronization in axis control";
  case ERR_RMRC_X: return "ERR_RMRC_X: Anomalous X axis synchronization in RMRC control";
  case ERR_RMRC_Y: return "ERR_RMRC_Y: Anomalous Y axis synchronization in RMRC control";
  case ERR_RMRC_Z: return "ERR_RMRC_Z: Anomalous Z axis synchronization in RMRC control";
    /* Anomalous synchronisation occurs when target and surrent value deviation
     *  exceed the allowable range. (Arm is not moving or rather delays motion.)
     */
  case ERR_VELOCITY: return "ERR_VELOCITY: Anomalous velocity deviation";
  case ERR_RMRC_YPR: return "ERR_RMRC_YPR: Anomalous tip orientaion deviation in RMRC control";
    /*===============*/
  case ERR_CUB_INN: return "ERR_CUB_INN: interfered with cube";
    /*===============*/
  case ERR_ARM_ERR0: return "ERR_ARM_ERR0: Motion start or continuation is not allowed at arm singularity";
  case ERR_ARM_ERR1: return "ERR_ARM_ERR1: Motion start or continuation is not allowed at arm singularity";
  case ERR_ARM_ERR2: return "ERR_ARM_ERR2: Motion start or continuation is not allowed at arm singularity";
    /* Fatal error --> (Control stop status) */	
  case ERR_POWER_ON: return "ERR_POWER_ON: Control not started";
    /* After fatal error occured without issuing control start command, if other
     *  command is issued, this error occurs.
     */
  case ERR_EM_CTL: return "ERR_EM_CTL: Emergency stop is pushed";
case ERR_ARC_SEND: return "ERR_ARC_SEND: Anomalous arc net communication";
case ERR_S1X_LIM: return "ERR_S1X_LIM: S1 axis limit switch ON";
case ERR_DRV_TYP: return "ERR_DRV_TYP: Servo driver type is different from parameter designation";
case ERR_FORCE_ON: return "ERR_FORCE_ON: Not in force control";
    /*===============*/
  case ERR_DDD_STA: return "ERR_DDD_STA: Anomalous communication control servo (master) status";
  case ERR_D11_STA: return "ERR_D11_STA: Anomalous servo driver (S1) status";
  case ERR_D12_STA: return "ERR_D12_STA: Anomalous servo driver (S2) status";
  case ERR_D21_STA: return "ERR_D21_STA: Anomalous servo driver (S3) status";
  case ERR_D22_STA: return "ERR_D22_STA: Anomalous servo driver (E1) status";
  case ERR_D31_STA: return "ERR_D31_STA: Anomalous servo driver (E2) status";
  case ERR_D32_STA: return "ERR_D32_STA: Anomalous servo driver (W1) status";
  case ERR_D41_STA: return "ERR_D41_STA: Anomalous servo driver (W2) status";
    /* Anomalous servo driver is the case when servo driver detects any anomaly 
     *  and turns into waiting status after being released from control. For
     *  servo status, refer to ???(next page).
     */
  case ERR_S_SUSPD: return "ERR_S_SUSPD: Anomaly when issuing control (communication) start command";
  case ERR_E_SUSPD: return "ERR_E_SUSPD: Anomaly when issuing control (communication end command";
  case ERR_I_SUSPD: return "ERR_I_SUSPD: Anomaly when issuing initialisation command";
    /* Anomalous control command issuing means when issuing comand to the servo 
     *  driver, there is no response for a certain time. (servo driver is
     *  anomalous.)
     */
  case ERR_MOD_CTL: return "ERR_MOD_CTL: Anomalous mode management";
    /* (3) Servo status driver detection error */
    /*
     * more information, referto servo driver operation manual and (3) error
     *  information in section 6.14.1 of the PA10 programming manual.
     */
  case DRV_MEM_ERR: return "DRV_MEM_ERR Anomalous shared memory";
  case EEP_ROM_ERR: return "EEP_ROM_ERR Anomalous EEPROM";
  case CPU_XXX_ERR: return "CPU_XXX_ERR Anomalous CPU";
  case ARC_NET_ERR: return "ARC_NET_ERR Anomalous communication cycle";
  case VEL_SPN_ERR: return "VEL_SPN_ERR Anomalous velocity deviation";
  case REZ_SPN_ERR: return "REZ_SPN_ERR Anomalous resolver deviation";
  case VEL_LIM_ERR: return "VEL_LIM_ERR Anomalous position limit";
  case MTR_TRQ_ERR: return "MTR_TRQ_ERR Anomalous motor torque";
  case IPM_XXX_ERR: return "IPM_XXX_ERR Anomalous IPM";
  case BRK_XXX_ERR: return "BRK_XXX_ERR Severed brake line";
  case REZ_001_ERR: return "REZ_001_ERR Severed resolver line (gear side)";
  case REZ_002_ERR: return "REZ_002_ERR Severed resolver line (motor side)";
  case OVR_TRQ_ERR: return "OVR_TRQ_ERR Over current";
  case OVR_VEL_ERR: return "OVR_VEL_ERR Over velocity";
  case DMS_XXX_ERR: return "DMS_XXX_ERR Anomalous dead man SW";
  case CPU_NON_ERR: return "CPU_NON_ERR Other anomalous CPU";
  default: 
    if (numError > 16 || numError < -4000)
      return "Not a paLib error";
    return "default: unknown error";
  }
}


