
if { [info proc gbload] == "" } {
#    source /home/daniel/robots/pa10/gbM/gb.tcl
    source /home/daniel/robots/pa10/gbM-configure/gb.tcl
}

# For pa_set_tim : 20 is 200 ms
set ::paPositionXUpdateDelay 100

set f .paPositionX
if { [winfo exist $f ] } { destroy $f }

toplevel $f

button $f.stop -text "Stop (break)" -command pa_stop -background red

button $f.close -text Close -command "paPositionXStop; destroy $f"

button $f.reset -text "Stop (at curent Position)" -command paPositionXStop

button $f.updates -text "Updates sliders" -command paPositionXUpdate

button $f.goto -text "Start position control" -command paPositionXGoto

foreach el { px py pz  rx ry rz ra } {
    frame $f.$el
    label $f.$el.l -text $el
    scale $f.$el.s -length 200 -variable ::paPositionX[set el] \
	-orient horizontal -tickinterval 0 \
	-command "set ::paPositionX[set el]"
    eval pack [winfo children $f.$el] -side left
}

$f.px.s configure -from -1000 -to 1000   -resolution 0.1
$f.py.s configure -from -1000 -to 1000   -resolution 0.1
$f.pz.s configure -from -1000 -to 1500   -resolution 0.1
$f.rx.s configure -from -1 -to 1         -resolution 0.001
$f.ry.s configure -from -1 -to 1         -resolution 0.001
$f.rz.s configure -from -1 -to 1         -resolution 0.001
$f.ra.s configure -from -$M_PI -to $M_PI -resolution 0.01

foreach el { px py pz  rx ry rz ra } {
    $f.$el.s configure -tickinterval \
	[expr [$f.$el.s cget -to] - [$f.$el.s cget -from] - 0.009]
}

eval pack [winfo children $f]

proc paPositionXStop { } {
    # may be it's not the good solution
    proc paUpdatePositionX { } { }
    set status [pa_sus_arm $::armNo $::WM_NOWAIT]
    paErrorStatus pa_sus_arm $status
}

set paPositionXMatrix [MATRIXS paPositionXMatrix]

proc paPositionXUpdate { } {
    set status [pa_get_noa $::armNo $::paPositionXMatrix]
    paErrorStatus pa_get_noa $status 
    paMatrixTh $::paPositionXMatrix $::paPositionXTh
    Gb_th_dep $::paPositionXTh $::paPositionXDep

    set ::paPositionXpx [$::paPositionXDep cget -x]
    set ::paPositionXpy [$::paPositionXDep cget -y]
    set ::paPositionXpz [$::paPositionXDep cget -z]
    set ::paPositionXrx [$::paPositionXDep cget -rx]
    set ::paPositionXry [$::paPositionXDep cget -ry]
    set ::paPositionXrz [$::paPositionXDep cget -rz]
    set ::paPositionXra [$::paPositionXDep cget -a]
}

proc paPositionXGoto { } {
    paPositionXUpdate
    set status [pa_set_tim $::armNo $::paPositionXUpdateDelay]
    paErrorStatus pa_set_tim $status

    set status [pa_mod_jou $::armNo $::JM_OFF]
    paErrorStatus pa_mod_jou $status
    set status [pa_mod_dpd $::armNo]
    paErrorStatus pa_mod_dpd $status
    define_paUpdatePositionX
    #paUpdatePositionX
}

set paPositionXANGLE [ANGLE paPositionXANGLE]
ANGLESet $paPositionXANGLE 0 0 0  0 0 0  0

proc define_paUpdatePositionX { } {
    proc paUpdatePositionX { } {
	Gb_dep_set $::paPositionXDep \
	    $::paPositionXpx $::paPositionXpy $::paPositionXpz \
	    $::paPositionXrx $::paPositionXry $::paPositionXrz $::paPositionXra
	Gb_dep_th $::paPositionXDep $::paPositionXTh
	paThMatrix $::paPositionXTh $::paPositionXMatrix
	set status [pa_odr_dpd $::armNo \
			$::paPositionXMatrix $::paPositionXANGLE]
	paErrorStatus pa_odr_dpd $status
	after 100 paUpdatePositionX
    }
}

set paPositionXTh [Gb_th paPositionXTh]

proc paThMatrix { th matrix } {
    MATRIXS_vxx_set $matrix [[$th cget -vx] cget -x ]
    MATRIXS_vxy_set $matrix [[$th cget -vx] cget -y ]
    MATRIXS_vxz_set $matrix [[$th cget -vx] cget -z ]
    MATRIXS_vyx_set $matrix [[$th cget -vy] cget -x ]
    MATRIXS_vyy_set $matrix [[$th cget -vy] cget -y ]
    MATRIXS_vyz_set $matrix [[$th cget -vy] cget -z ]
    MATRIXS_vzx_set $matrix [[$th cget -vz] cget -x ]
    MATRIXS_vzy_set $matrix [[$th cget -vz] cget -y ]
    MATRIXS_vzz_set $matrix [[$th cget -vz] cget -z ]
    MATRIXS_vpx_set $matrix [[$th cget -vp] cget -x ]
    MATRIXS_vpy_set $matrix [[$th cget -vp] cget -y ]
    MATRIXS_vpz_set $matrix [[$th cget -vp] cget -z ]
}

proc paMatrixTh { matrix th } {
    [$th cget -vx] configure -x [MATRIXS_vxx_get $matrix]
    [$th cget -vx] configure -y [MATRIXS_vxy_get $matrix]
    [$th cget -vx] configure -z [MATRIXS_vxz_get $matrix]
    [$th cget -vy] configure -x [MATRIXS_vyx_get $matrix]
    [$th cget -vy] configure -y [MATRIXS_vyy_get $matrix]
    [$th cget -vy] configure -z [MATRIXS_vyz_get $matrix]
    [$th cget -vz] configure -x [MATRIXS_vzx_get $matrix]
    [$th cget -vz] configure -y [MATRIXS_vzy_get $matrix]
    [$th cget -vz] configure -z [MATRIXS_vzz_get $matrix]
    [$th cget -vp] configure -x [MATRIXS_vpx_get $matrix]
    [$th cget -vp] configure -y [MATRIXS_vpy_get $matrix]
    [$th cget -vp] configure -z [MATRIXS_vpz_get $matrix]
}

paMatrixTh $paPositionXMatrix paPositionXTh

set status [pa_get_noa $::armNo $::paPositionXMatrix]
paErrorStatus pa_get_noa $status

paMatrixTh $::paPositionXMatrix $::paPositionXTh

Gb_th_print $paPositionXTh

set paPositionXDep [Gb_dep paPositionXDep]

Gb_th_dep $::paPositionXTh $::paPositionXDep

puts [Gb_dep_get $::paPositionXDep]

set ::paPositionXpx [$::paPositionXDep cget -x]
set ::paPositionXpy [$::paPositionXDep cget -y]
set ::paPositionXpz [$::paPositionXDep cget -z]
set ::paPositionXrx [$::paPositionXDep cget -rx]
set ::paPositionXry [$::paPositionXDep cget -ry]
set ::paPositionXrz [$::paPositionXDep cget -rz]
set ::paPositionXra [$::paPositionXDep cget -a]

Gb_dep_set $::paPositionXDep \
    $::paPositionXpx $::paPositionXpy $::paPositionXpz \
    $::paPositionXrx $::paPositionXry $::paPositionXrz $::paPositionXra

Gb_dep_th $::paPositionXDep $::paPositionXTh

Gb_th_print $paPositionXTh

puts ""

