#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

#exec /home/daniel/mytmp/bin/wish8.4 "$0" "$@"

if { [info exist pa_loaded] == 0 } {
    load [file dirname [info script]]/pa_wrap.so pa
    set pa_loaded loadded
    rename exit tcl_exit
    proc exit { args } {
	puts "Arret du bras"
	myQuit
	eval tcl_exit $args
    }
} 
#pour eviter de detruire certaines fenetre
set lwindow [winfo children .]
set pos [string first .jr3 $lwindow]
if { $pos >= 0 } {
    set lwindow [string replace $lwindow $pos [expr $pos + 4] ""]
}

eval destroy $lwindow


set armNo 0


proc ANGLEGet { a } {
    return [list \
		[$a cget -s1] \
		[$a cget -s2] \
		[$a cget -s3] \
		[$a cget -e1] \
		[$a cget -e2] \
		[$a cget -w1] \
		[$a cget -w2] \
	       ]
}

proc ANGLESet { a s1 s2 s3 e1 e2 w1 w2 } {
    foreach el { s1 s2 s3 e1 e2 w1 w2 } {
	ANGLE_[set el]_set [set a] [set [set el]]
    }
}


proc paErrorStatusN { message status } {
    if { $status >= 0 } return
    puts "paErrorStatusN $status < 0"
    error "paErrorStatus: $message ($status [pa10ErrorGetString $status])"
}

proc paErrorStatus { message status { OK 0 } } {
    #    puts "paErrorStatus $status == $OK"
    if { $status == $OK } return
    puts "paErrorStatus $status == $OK"
    error "paErrorStatus: $message ($status [pa10ErrorGetString $status])"
}
    
proc pa_init { } {
    set status [pa_ini_sys]
    paErrorStatus pa_ini_sys $status
    set status [pa_opn_arm $::armNo]
    paErrorStatusN pa_opn_arm $status

    set status [pa_sta_arm $::armNo]
    paErrorStatusN pa_sta_arm $status
    set ::test_pa_init_ok 1
}

proc pa_stop { } {
    set status [pa_stp_arm $::armNo $::WM_NOWAIT]
    paErrorStatus pa_stp_arm $status
}

proc pa_end { } {
    set status1 [pa_stp_arm $::armNo $::WM_NOWAIT]
    set status [pa_ext_arm $::armNo]
    paErrorStatus pa_stp_arm $status1
    paErrorStatus pa_ext_arm $status
}

proc b_pa_rst_ctl { } {
    set status [pa_rst_ctl $::armNo]
    paErrorStatus pa_rst_ctl $status
}

proc pa_goto_home { } {
    set status [pa_exe_hom $::armNo $::WM_NOWAIT]
    paErrorStatus pa_exe_hom $status
}

proc pa_goto_escape { } {
    set status [pa_exe_esc $::armNo $::WM_NOWAIT]
    paErrorStatus pa_exe_esc $status
}

proc pa_goto_safe { } {
    set status [pa_exe_saf $::armNo $::WM_NOWAIT]
    paErrorStatus pa_exe_saf $status
}

set f .l1
frame $f
button $f.quit -text Quit -command exit
button $f.help -text Help -command \
    "exec firefox https://intranet.laas.fr/intranet/robots/wiki/Pa10RapidMove"
button $f.stop -text "Stop (break)" -command pa_stop -background red
eval pack [winfo children $f] -side left

set f .l2
frame $f
button $f.init -text pa_init -command pa_init
button $f.servoOn -text "servo ON" -command paServoOn
button $f.reset -text "error information resetting" -command b_pa_rst_ctl
eval pack [winfo children $f] -side left

button .vitesse -text "Vitesse Q" \
    -command "source [file dirname [info script]]/vitesse.tcl"
button .position -text "Position Q" \
    -command "source [file dirname [info script]]/position.tcl"

set f .l5
frame $f
button $f.record -text Record -command test_record_position
button $f.update -text "Update scales" -command paGetpaQ7Update
button $f.goto -text "Goto slider position" -command  paGotoScalesPos
eval pack [winfo children $f] -side left

foreach el { s1 s2 e1 e2 w1 w2 } {
    frame .$el
    label .$el.l -text $el
    scale .$el.s -length 300 -variable paQ[set el] \
	-orient horizontal -resolution 0.01 -tickinterval 0
    eval pack [winfo children .$el] -side left
}

frame .gotoPa10
button .gotoPa10.home   -text "Goto Up"   -command pa_goto_home
button .gotoPa10.escape -text "Bend Vert" -command pa_goto_escape
button .gotoPa10.safe   -text "Bend Hori"   -command pa_goto_safe
eval pack [winfo children .gotoPa10] -side left

frame .gotoRest
button .gotoRest.sideh   -text "Fold Side H"  -command "paGotoP -1.55 -0.5 2.6 1.55 1.55 -1.70"
button .gotoRest.sidev   -text "Fold Side V"  -command "paGotoP -1.55 -0.5 2.6 0 0.95 0.43"
button .gotoRest.fronth   -text "Fold Front H" -command "paGotoP 0 -0.5 2.6 0 -0.5 0.43"
button .gotoRest.frontv -text "Fold Front V" -command "paGotoP 0 -0.5 2.6 0 0.95 0.43"
eval pack [winfo children .gotoRest] -side left

frame .gototcl
button .gototcl.p0 -text "Goto p0" -command {eval paGotoP $p0}
button .gototcl.p1 -text "Goto p1" -command {eval paGotoP $p1}
button .gototcl.p2 -text "Goto p2" -command {eval paGotoP $p2}
button .gototcl.p3 -text "Goto p3" -command {eval paGotoP $p3}
button .gototcl.p4 -text "Goto p4" -command {eval paGotoP $p4}
eval pack [winfo children .gototcl] -side left

set M_PI 3.14159265358979323846
proc degRad { d } {
    return [expr $::M_PI * $d / 180.]
}
.s1.s configure -from [degRad -177] -to [degRad 177]
.s2.s configure -from [degRad -64 ] -to [degRad 124]
.e1.s configure -from [degRad -107] -to [degRad 158]
.e2.s configure -from [degRad -255] -to [degRad 255]
.w1.s configure -from [degRad -165] -to [degRad 165]
.w2.s configure -from [degRad -255] -to [degRad 255]

foreach el { s1 s2 e1 e2 w1 w2 } {
    .$el.s configure -tickinterval \
	[expr [.$el.s cget -to] - [.$el.s cget -from] - 0.009]
}

set lwindow [winfo children .]
set pos [string first .jr3 $lwindow]
if { $pos >= 0 } {
    set lwindow [string replace $lwindow $pos [expr $pos + 4] ""]
}
eval pack $lwindow

proc myQuit { } {
    if { [info exist ::test_pa_init_ok] } {
	if { [catch { pa_stp_arm $::armNo $::WM_NOWAIT} tutu ] } { puts $tutu }
	if { [catch { pa_ext_arm $::armNo } tutu ] } { puts $tutu }
	if { [catch { pa_cls_arm $::armNo } tutu ] } { puts $tutu }
	if { [catch { pa_ter_sys } tutu ] } { puts $tutu }
    }
}



set paQ7 [ANGLE paQ7]
ANGLESet $::paQ7 1. 2. 3. 4. 5. 6. 7.
puts "paQ7= [ANGLEGet $::paQ7]"
puts "paQ7 $paQ7"

proc tt { } {
    puts "paQ7= [ANGLEGet $::paQ7]"
    uplevel \#0 {
	pa_get_agl_t 0 $paQ7
	pa_get_agl_t 0 $paQ7Speed
    }
}
#tt

proc paGetpaQ7Update { } {
    # pa_get_agl(Res.armNo,&angle);
    set status [pa_get_agl $::armNo $::paQ7]
    paErrorStatus pa_get_agl $status 
    foreach el { s1 s2 e1 e2 w1 w2 } {
	set ::paQ[set el] [ANGLE_[set el]_get $::paQ7]
    }
}

proc paServoOn { } {
    paGetpaQ7Update
    puts "paServoOn ::paQ7= [ANGLEGet $::paQ7]"
    #pa_exe_axs(Res.armNo,axis,&angle,WM_NOWAIT);
    set status [pa_exe_axs $::armNo [paAXISAllAxis] $::paQ7 $::WM_WAIT]
#    set status [pa_exe_axs $::armNo 0x01 $::paQ7 $::WM_NOWAIT]
    paErrorStatus pa_exe_axs $status
}

proc paGotoScalesPos { } {
    foreach el { s1 s2 e1 e2 w1 w2 } {
	$::paQ7 configure -[set el] [set ::paQ[set el]]
    }
    set a "paGotoScalesPos ::paQ7= [ANGLEGet $::paQ7]"
    puts $a
#    confirme "" "$a\nVoulez Vous vraiement effectuer ce déplacement ?" {
    set status [pa_exe_axs $::armNo [paAXISAllAxis] $::paQ7 $::WM_NOWAIT]
    paErrorStatus pa_exe_axs $status
#    } {}
}

proc paAXISAllAxis { } {
    set S1 0x01
    set S2 0x02
    set S3 0x04
    set E1 0x08
    set E2 0x10
    set W1 0x20
    set W2 0x40
    return [expr $S1 | $S2 | $E1 | $E2 | $W1 | $W2]
}

proc paGotoP { s1 s2 e1 e2 w1 w2 } {
    puts "paGotoP $s1 $s2 $e1 $e2 $w1 $w2 "
    foreach el { s1 s2 e1 e2 w1 w2 } {
	$::paQ7 configure -[set el] [set [set el]]
    }
    set status [pa_exe_axs $::armNo [paAXISAllAxis] $::paQ7 $::WM_NOWAIT]
    paErrorStatus pa_exe_axs $status
}

proc paGotoPWait { s1 s2 e1 e2 w1 w2 } {
    set status [pa_get_cnt $::armNo]
    paErrorStatus pa_get_cnt [lindex $status 0]
    set counter [lindex $status 1]
    paGotoP $s1 $s2 $e1 $e2 $w1 $w2
    while { 1 } {
	set status [pa_get_cnt $::armNo]
	paErrorStatus pa_get_agl [lindex $status 0]
	if { [lindex $status 1] != $counter } {
	    break
	}
	after 50
    }
}


proc confirme { chemin message action_oui action_non } {
    set r [tk_dialog $chemin.confirm Confirmer $message {} 0 OUI NON]
    if {$r == 0} {
        if { $action_oui != ""} {
            eval $action_oui
        }
    } else {
        if { $action_non != ""} {
            eval $action_non
        }
    }
}


set p0 " 0 0 [expr $M_PI/2]   0 0 -0.4 "
set p1 " 0 0 [expr $M_PI/2]   0 [expr -$M_PI/2] -0.4 "
set p2 " 0 0 [expr $M_PI/2]   0 [expr $M_PI/2] -0.4 "
set p3 " 0 0 [expr $M_PI/2]   0 0 [expr -0.4 + $M_PI/2] "
set p4 " 0 0 [expr $M_PI/2]   0 0 [expr -0.4 - $M_PI/2] "

#set p0 " 0 0 [expr $M_PI/2]   0 0 0.89 "
#set p3 " 0 0 [expr $M_PI/2]   0 0 [expr 0.89 + $M_PI/2] "
#set p4 " 0 0 [expr $M_PI/2]   0 0 [expr 0.89 - $M_PI/2] "
#set p2 " 0 0 [expr $M_PI/2]   0 0 [expr 0.89 - $M_PI] "

#      status = pa_exe_axs(PA10_ARM_NUMBER, ALLAXIS, &angle, WM_WAIT);

set paGetpaQ_q7 [ANGLE paGetpaQ_q7]
proc paGetpaQ { } {
    # pa_get_agl(Res.armNo,&angle);
    set status [pa_get_agl $::armNo $::paGetpaQ_q7]
    paErrorStatus pa_get_agl $status 
    set ret ""
    foreach el { -s1 -s2 -e1 -e2 -w1 -w2 } {
	set ret [linsert $ret end [$::paGetpaQ_q7 cget $el] ]
    }
    return $ret
}


#STATUS qarmGetArmStatusCntrl (int *bilan)
#{
#  ARMSTATUS armstatus;
#  long status;
#
#  status = pa_get_sts(PA10_ARM_NUMBER, &armstatus);
#  PA10_ERROR_RETURN(status, "qarmGetArmStatusCntrl: pa_get_sts",
#		    S_qarm_PALIB_ERROR);
#  SDI_F->state.iarm.armStatus.max    = armstatus.max;
#  SDI_F->state.iarm.armStatus.arm    = armstatus.arm;
#  SDI_F->state.iarm.armStatus.axis   = armstatus.axis;
#  SDI_F->state.iarm.armStatus.typ    = armstatus.typ;
#  SDI_F->state.iarm.armStatus.drv    = armstatus.drv;
#  SDI_F->state.iarm.armStatus.dio    = armstatus.dio;
#  SDI_F->state.iarm.armStatus.remote = armstatus.remote;
#  SDI_F->state.iarm.armStatus.count  = armstatus.count;
#  SDI_F->state.iarm.armStatus.error  = armstatus.error;
#  SDI_F->state.iarm.armStatus.angle.s1 = armstatus.angle.s1;
#  SDI_F->state.iarm.armStatus.angle.s2 = armstatus.angle.s2;
#  SDI_F->state.iarm.armStatus.angle.s3 = armstatus.angle.s3;
#  SDI_F->state.iarm.armStatus.angle.e1 = armstatus.angle.e1;
#  SDI_F->state.iarm.armStatus.angle.e2 = armstatus.angle.e2;
#  SDI_F->state.iarm.armStatus.angle.w1 = armstatus.angle.w1;
#  SDI_F->state.iarm.armStatus.angle.w2 = armstatus.angle.w2;
#  SDI_F->state.iarm.armStatus.noap.vx.x = armstatus.noap[0][0];
#  SDI_F->state.iarm.armStatus.noap.vx.y = armstatus.noap[1][0];
#  SDI_F->state.iarm.armStatus.noap.vx.z = armstatus.noap[2][0];
#  SDI_F->state.iarm.armStatus.noap.vy.x = armstatus.noap[0][1];
#  SDI_F->state.iarm.armStatus.noap.vy.y = armstatus.noap[1][1];
#  SDI_F->state.iarm.armStatus.noap.vy.z = armstatus.noap[2][1];
#  SDI_F->state.iarm.armStatus.noap.vz.x = armstatus.noap[0][2];
#  SDI_F->state.iarm.armStatus.noap.vz.y = armstatus.noap[1][2];
#  SDI_F->state.iarm.armStatus.noap.vz.z = armstatus.noap[2][2];
#  SDI_F->state.iarm.armStatus.noap.vp.x = armstatus.noap[0][3];
#  SDI_F->state.iarm.armStatus.noap.vp.y = armstatus.noap[1][3];
#  SDI_F->state.iarm.armStatus.noap.vp.z = armstatus.noap[2][3];
#  SDI_F->state.iarm.armStatus.ypr[0] = armstatus.ypr[0];
#  SDI_F->state.iarm.armStatus.ypr[1] = armstatus.ypr[1];
#  SDI_F->state.iarm.armStatus.ypr[2] = armstatus.ypr[2];
#
#  return OK;
#}

proc pa_sav_sts_f { } {
    set status [PA_SAV_STS_STATUS status]
    pa_sav_sts $::armNo status
    puts "[PA_SAV_STS_STATUS_s1_get     status]"
    puts "[PA_SAV_STS_STATUS_s2_get     status]"
    puts "[PA_SAV_STS_STATUS_s3_get     status]"
    puts "[PA_SAV_STS_STATUS_e1_get     status]"
    puts "[PA_SAV_STS_STATUS_e2_get     status]"
    puts "[PA_SAV_STS_STATUS_w1_get     status]"
    puts "[PA_SAV_STS_STATUS_w2_get     status]"
    puts "[PA_SAV_STS_STATUS_master_get status]"
    puts "status s1     [pa10ErrorGetString [PA_SAV_STS_STATUS_s1_get     status]]"
    puts "status s2     [pa10ErrorGetString [PA_SAV_STS_STATUS_s2_get     status]]"
    puts "status s3     [pa10ErrorGetString [PA_SAV_STS_STATUS_s3_get     status]]"
    puts "status e1     [pa10ErrorGetString [PA_SAV_STS_STATUS_e1_get     status]]"
    puts "status e2     [pa10ErrorGetString [PA_SAV_STS_STATUS_e2_get     status]]"
    puts "status w1     [pa10ErrorGetString [PA_SAV_STS_STATUS_w1_get     status]]"
    puts "status w2     [pa10ErrorGetString [PA_SAV_STS_STATUS_w2_get     status]]"
    puts "status master [pa10ErrorGetString [PA_SAV_STS_STATUS_master_get status]]"
}

#
#  Record
#
# test_record_position : record pa10 position in file and define new 
#      goTo button in tolevel window .test_record
set ::test_record_position_file records.tcl
proc test_record_position { } {
    set status [pa_get_agl $::armNo $::paQ7]
    paErrorStatus pa_get_agl $status 
    set position ""
    foreach el { s1 s2 e1 e2 w1 w2 } {
	lappend position [ANGLE_[set el]_get $::paQ7]
    }
    set time [clock click]
    set line "\n"
    set w .test_record.$time
    set name "New position $time $position"
    set line "$line button $w -text \"$name\"  -command \"paGotoP $position\""

    puts "line= $line"
    set file [open $::test_record_position_file a+]
    puts $file ""
    puts $file $line
    close $file

    if { [winfo exist .test_record] } {
	eval destroy [winfo children .test_record]
    } else {
	toplevel .test_record
    }
    button .test_record.record -text Record -command test_record_position
    source $::test_record_position_file
    eval pack [winfo children .test_record]
}


